/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "ld_script_parser.y"
/*-
 * Copyright (c) 2010-2013 Kai Wang
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "ld.h"
#include "ld_arch.h"
#include "ld_options.h"
#include "ld_output.h"
#include "ld_script.h"
#include "ld_file.h"
#include "ld_path.h"
#include "ld_exp.h"

ELFTC_VCSID("$Id: ld_script_parser.y 3281 2015-12-11 21:39:23Z kaiwang27 $");

struct yy_buffer_state;
typedef struct yy_buffer_state *YY_BUFFER_STATE;

#ifndef	YY_BUF_SIZE
#define	YY_BUF_SIZE 16384
#endif

extern int yylex(void);
extern int yyparse(void);
extern YY_BUFFER_STATE yy_create_buffer(FILE *file, int size);
extern YY_BUFFER_STATE yy_scan_string(char *yy_str);
extern void yy_switch_to_buffer(YY_BUFFER_STATE b);
extern void yy_delete_buffer(YY_BUFFER_STATE b);
extern int lineno;
extern FILE *yyin;
extern struct ld *ld;

static void yyerror(const char *s);
static void _init_script(void);
static struct ld_script_cmd_head ldss_c, ldso_c;

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 256 "ld_script_parser.y"
typedef union {
	struct ld_exp *exp;
	struct ld_script_assign *assign;
	struct ld_script_cmd *cmd;
	struct ld_script_list *list;
	struct ld_script_input_file *input_file;
	struct ld_script_phdr *phdr;
	struct ld_script_region *region;
	struct ld_script_sections_output *output_desc;
	struct ld_script_sections_output_data *output_data;
	struct ld_script_sections_output_input *input_section;
	struct ld_script_sections_overlay *overlay_desc;
	struct ld_script_sections_overlay_section *overlay_section;
	struct ld_script_version_entry *version_entry;
	struct ld_script_version_entry_head *version_entry_head;
	struct ld_wildcard *wildcard;
	char *str;
	int64_t num;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 109 "ld_script_parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define T_ABSOLUTE 257
#define T_ADDR 258
#define T_ALIGN 259
#define T_ALIGNOF 260
#define T_ASSERT 261
#define T_AS_NEEDED 262
#define T_AT 263
#define T_BIND 264
#define T_BLOCK 265
#define T_BYTE 266
#define T_CONSTANT 267
#define T_CONSTRUCTORS 268
#define T_CREATE_OBJECT_SYMBOLS 269
#define T_DATA_SEGMENT_ALIGN 270
#define T_DATA_SEGMENT_END 271
#define T_DATA_SEGMENT_RELRO_END 272
#define T_DEFINED 273
#define T_ENTRY 274
#define T_EXCLUDE_FILE 275
#define T_EXTERN 276
#define T_FILEHDR 277
#define T_FILL 278
#define T_FLAGS 279
#define T_FLOAT 280
#define T_FORCE_COMMON_ALLOCATION 281
#define T_GROUP 282
#define T_HLL 283
#define T_INCLUDE 284
#define T_INHIBIT_COMMON_ALLOCATION 285
#define T_INPUT 286
#define T_KEEP 287
#define T_LENGTH 288
#define T_LOADADDR 289
#define T_LONG 290
#define T_MAP 291
#define T_MAX 292
#define T_MEMORY 293
#define T_MIN 294
#define T_NEXT 295
#define T_NOCROSSREFS 296
#define T_NOFLOAT 297
#define T_OPTION 298
#define T_ORIGIN 299
#define T_OUTPUT 300
#define T_OUTPUT_ARCH 301
#define T_OUTPUT_FORMAT 302
#define T_PHDRS 303
#define T_PROVIDE 304
#define T_PROVIDE_HIDDEN 305
#define T_QUAD 306
#define T_REGION_ALIAS 307
#define T_SEARCH_DIR 308
#define T_SECTIONS 309
#define T_SEGMENT_START 310
#define T_SHORT 311
#define T_SIZEOF 312
#define T_SIZEOF_HEADERS 313
#define T_SORT_BY_ALIGNMENT 314
#define T_SORT_BY_NAME 315
#define T_SPECIAL 316
#define T_SQUAD 317
#define T_STARTUP 318
#define T_SUBALIGN 319
#define T_SYSLIB 320
#define T_TARGET 321
#define T_TRUNCATE 322
#define T_VER_EXTERN 323
#define T_VER_GLOBAL 324
#define T_VER_LOCAL 325
#define T_LSHIFT_E 326
#define T_RSHIFT_E 327
#define T_LSHIFT 328
#define T_RSHIFT 329
#define T_EQ 330
#define T_NE 331
#define T_GE 332
#define T_LE 333
#define T_ADD_E 334
#define T_SUB_E 335
#define T_MUL_E 336
#define T_DIV_E 337
#define T_AND_E 338
#define T_OR_E 339
#define T_LOGICAL_AND 340
#define T_LOGICAL_OR 341
#define UNARY 342
#define T_NUM 343
#define T_COMMONPAGESIZE 344
#define T_COPY 345
#define T_DSECT 346
#define T_IDENT 347
#define T_INFO 348
#define T_MAXPAGESIZE 349
#define T_MEMORY_ATTR 350
#define T_NOLOAD 351
#define T_ONLY_IF_RO 352
#define T_ONLY_IF_RW 353
#define T_OVERLAY 354
#define T_STRING 355
#define T_WILDCARD 356
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,   80,   80,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   15,   16,
   17,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   37,   38,   39,   13,   13,   72,
   72,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
    7,    7,    1,    1,    1,    4,    2,    3,   52,   52,
   52,   52,   52,   52,   52,   52,   52,    5,    6,   81,
   82,   83,   84,   85,   86,   97,   97,   64,   66,   66,
   87,   88,   89,   90,   90,   91,   98,   98,   63,   56,
   56,   58,   58,   36,   36,   57,   57,   92,   93,    9,
   99,   99,   10,   10,   10,   10,   10,  100,   60,   48,
   48,   30,   70,   70,   70,   71,   71,   71,   71,   71,
   33,   33,   31,   31,   34,   34,   67,   67,   67,  101,
  101,    8,    8,    8,    8,    8,   42,   42,   43,   43,
   41,   41,   59,   53,   53,   53,   53,   53,   53,   54,
   54,   54,   69,   69,   68,   68,   49,   49,   32,   32,
   61,   35,   35,   55,   55,   50,   50,   62,   94,   95,
   96,   96,   96,   96,   78,   76,   77,   77,   75,   75,
   75,   75,   79,   79,   65,   65,   14,   14,   73,   73,
   73,   73,   74,   74,   74,   74,   74,   74,   74,   45,
   45,   46,   46,   47,   47,   40,   40,   44,   51,   51,
  102,  102,
};
static const YYINT yylen[] = {                            2,
    1,    0,    1,    2,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    2,    2,    5,    1,    1,    1,    1,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    4,    4,
    4,    6,    4,    4,    6,    4,    6,    4,    4,    4,
    6,    6,    4,    4,    6,    4,    1,    1,    1,    4,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    3,    6,    6,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    6,    4,    4,
    1,    4,    1,    4,    4,    1,    2,   10,    1,    0,
    4,    4,    4,    4,    8,    4,    1,    2,    7,    1,
    0,    1,    0,    4,    0,    4,    0,    6,    4,    4,
    1,    2,    1,    1,    1,    1,    1,    0,   15,    2,
    1,    1,    3,    2,    0,    1,    1,    1,    1,    1,
    4,    0,    4,    0,    4,    0,    1,    1,    0,    1,
    2,    1,    1,    1,    1,    1,    1,    4,    2,    4,
    7,    3,    4,    1,    1,    1,    1,    1,    1,    1,
    1,    4,    2,    0,    3,    0,    3,    0,    2,    0,
   11,    1,    0,    1,    0,    1,    2,    6,    4,    4,
    4,    4,    3,    3,    3,    3,    1,    2,    1,    1,
    2,    2,    1,    0,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    4,    7,    7,    4,    7,    7,    1,
    3,    1,    2,    1,    3,    1,    1,    4,    1,    2,
    1,    0,
};
static const YYINT yydefred[] = {                         0,
    0,    0,    0,  111,    0,  113,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  225,  226,   92,    0,  228,    0,   73,   94,   95,
   93,   72,   74,    3,   88,    0,    0,    0,    0,    0,
   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
   85,   86,   87,   89,   90,   91,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  219,  220,  232,  231,  230,
  229,    0,  217,    0,    0,   99,  100,  101,  102,  103,
  104,  105,  106,  107,    0,    0,    0,  223,    0,    0,
    4,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   67,
    0,   68,    0,    0,    0,   26,    0,   27,   28,    0,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
   41,   42,   43,   44,   45,   46,   47,   48,  227,   69,
    0,    0,  242,    0,  244,  247,    0,  246,    0,  116,
    0,    0,    0,    0,    0,    0,  127,    0,    0,    0,
    0,    0,    0,    0,  147,  144,  143,  141,  145,  146,
    0,    0,    0,    0,  215,  221,  216,  218,  222,    0,
    0,    0,  214,  213,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   23,   22,   24,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  109,  110,  243,    0,  112,
  251,    0,  114,  119,    0,  115,  117,  121,  122,  123,
  124,    0,    0,  126,  128,    0,    0,    0,  139,    0,
    0,    0,    0,    0,    0,  151,  140,  142,  209,  210,
  212,  211,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   30,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    7,    8,    9,
    0,    0,  240,  245,    0,    0,  130,    0,    0,    0,
    0,    0,  156,  157,  158,  159,  160,  154,    0,    0,
  150,  148,   49,   50,   51,    0,   53,   54,   70,   71,
    0,   56,    0,   58,   59,   60,    0,    0,   63,   64,
    0,   66,    0,  108,  248,    0,    0,    0,  132,    0,
   97,   98,  138,  204,    0,  153,    0,    0,    0,    0,
    0,    0,    0,    0,  241,    0,    0,    0,    0,    0,
    0,    0,   52,   55,   57,   61,   62,   65,    0,  125,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  129,    0,    0,  206,    0,    0,    0,    0,    0,  134,
    0,  161,    0,  207,    0,    0,    0,  167,  168,    0,
    0,  136,    0,  198,  184,  191,  190,  189,    0,  186,
  187,  185,    0,    0,  188,  176,  172,  170,  173,  177,
    0,  175,  174,    0,  233,    0,    0,  163,    0,    0,
    0,  193,    0,    0,    0,    0,    0,    0,    0,  179,
  198,  171,  165,    0,    0,    0,  201,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  249,    0,    0,    0,  197,    0,  178,    0,    0,  237,
  192,    0,    0,  234,  183,  180,    0,  182,  250,  208,
    0,    0,    0,    0,    0,    0,    0,  198,    0,    0,
    0,    0,    0,    0,    0,  239,  238,  236,  235,    0,
  195,  149,  181,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  261,  274,  276,  281,  282,  285,  286,  293,  296,  300,
  301,  302,  303,  304,  305,  307,  308,  309,  318,  321,
  323,  347,  355,   59,  123,   46,  358,  359,  360,  361,
  362,  363,  364,  365,  367,  372,  423,  434,  436,  438,
  439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
  449,  450,  451,  452,  453,  454,   40,   40,   40,   40,
   40,  123,   40,   40,   40,   40,  123,   40,   40,   40,
   40,  123,   40,   40,  355,  324,  325,   63,   42,  356,
  423,  431,  433,  435,  436,  326,  327,  334,  335,  336,
  337,  338,  339,   61,  410,  434,  436,  423,  437,  437,
  365,  257,  258,  259,  260,  265,  267,  270,  271,  272,
  273,  288,  289,  292,  294,  295,  299,  310,  312,  313,
   45,  343,   33,  126,   40,  362,  369,  370,  371,  372,
  373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
  383,  384,  385,  386,  387,  395,  396,  397,  423,  430,
  423,  404,  423,  262,  398,  402,  405,  423,  405,  422,
  423,  455,  404,  423,  423,  423,  421,  423,  456,  372,
  372,  423,  423,  354,   59,  359,  364,  368,  418,  419,
  423,  457,  423,  423,  434,   59,  125,  433,   59,  369,
  437,  437,   59,   59,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,  369,  369,  369,  369,  328,  329,  330,  331,
  332,  333,  340,  341,   63,  124,   38,   62,   60,   43,
   45,   42,   47,   37,   44,   41,   41,  423,   40,   41,
   44,  460,   41,  350,  424,  125,  422,   41,   41,   41,
   41,   44,  423,  125,  421,   61,   61,   44,   41,  369,
  393,   40,  369,  388,  406,  428,  125,  368,   41,   41,
   59,   59,  369,  423,  369,  423,  369,  344,  349,  369,
  369,  369,  423,  423,  423,  369,  369,  369,  423,  423,
  423,   41,  369,  369,  369,  369,  369,  369,  369,  369,
  369,  369,  369,  369,  369,  369,  369,  369,  369,  369,
  355,  403,  423,  398,   58,  423,  277,  414,  369,  369,
  423,   58,  345,  346,  348,  351,  354,   41,  429,   40,
  428,   58,   41,   41,   41,   44,   41,   41,   41,   41,
   44,   41,   44,   41,   41,   41,   44,   44,   41,   41,
   44,   41,   58,   41,   41,  460,  299,   44,  303,  416,
   41,   41,   41,  296,  413,   41,  458,  369,  369,  369,
  369,  369,  369,  369,  423,   61,  423,  263,  394,  263,
  391,  391,   41,   41,   41,   41,   41,   41,  369,   41,
   40,  279,  415,   40,  123,  259,  389,   44,  369,   40,
   59,  369,  408,  420,  423,   40,  319,  392,  288,   41,
  343,   41,  125,  420,  123,  369,   40,  352,  353,  425,
   61,   41,   62,  427,  266,  268,  269,  278,  287,  290,
  306,  311,  314,  315,  317,   59,  359,  366,  400,  401,
  411,  412,  417,  423,  431,  432,  459,   41,  369,  123,
  369,  423,  407,   40,   40,   40,   40,   58,   40,  399,
  125,  366,   41,  459,   61,   58,  390,  315,  401,  314,
  315,  431,  268,  314,  315,  431,  369,  432,  275,  409,
  432,  407,  125,  369,  423,   40,   41,   40,   40,   41,
   41,   40,   40,   41,   41,  399,   40,   41,  432,  390,
  427,  431,  431,  431,  431,  409,  263,  426,   41,   41,
   41,   41,   41,   62,  407,   41,   41,   41,   41,  409,
  423,  390,   41,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                         27,
  437,   29,   30,  126,   32,   33,   34,  438,   35,  178,
  216,  128,  129,  130,  131,  132,  133,  134,  135,  136,
  137,  138,  139,  140,  141,  142,  143,  144,  145,  264,
  397,  467,  381,  408,  261,  379,  146,  147,  148,  155,
  460,  439,  440,  156,  312,  152,  157,  265,  453,  403,
  480,   95,  441,  442,  365,  318,  393,  360,  443,  179,
  180,  404,  167,  160,  149,  245,  420,  508,  424,  266,
  329,  150,  445,  446,   83,   38,   84,   39,   99,   40,
   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
   51,   52,   53,   54,   55,   56,  162,  169,  182,  367,
  447,  242,
};
static const YYINT yysindex[] = {                      1663,
   15,   55,   62,    0,   76,    0,   82,  -74,   84,  109,
  111,  116,  -47,  120,  122,  125,  128,  -19,  138,  140,
 -330,    0,    0,    0,   52,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -56, -106, -302, -302, 1663,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   74, -302, -302, -230,
 -230, -302, -302, -302, -302, -302, -302,  -43,  -43, -302,
 -302,  423, -302, -302,   51,    0,    0,    0,    0,    0,
    0,   79,    0,   47,  123,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   74, -302, -302,    0,  126,  127,
    0,  144,  147,  148,  149,  150,  151,  152,  154,  155,
  156,  161,  162,  163,  169,  175,  176,  178,  179,    0,
   74,    0,   74,   74,   74,    0, 1945,    0,    0,  -56,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  173,  -41,    0,  180,    0,    0,   -6,    0,   87,    0,
 -129,  -98,  -29,  181,  182,   91,    0, -302,  -97,  164,
  190,  186,  195,   74,    0,    0,    0,    0,    0,    0,
  859,  284,  201,  211,    0,    0,    0,    0,    0, 4110,
  196,  206,    0,    0,   74, -302,   74, -302,   74, -210,
   74,   74,   74, -302, -302, -302,   74,   74,   74, -302,
 -302, -302,    0,    0,    0, 1262,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74, -101,    0,    0,    0, -302,    0,
    0, -230,    0,    0,  209,    0,    0,    0,    0,    0,
    0, -302,   13,    0,    0,   74,   74, -302,    0, 4110,
  214,  -26, 4110,  248,  231,    0,    0,    0,    0,    0,
    0,    0, 1567,  250, 1520,  251, 2082,  252,  255, 1977,
 2325, 2339,  256,  257,  258, 2492, 2902, 3501,  259,  261,
  267,    0,  134,  134,   99,   99,   99,   99, 3895, 2383,
 3528, 1123, 1915,   99,   99,  110,  110,    0,    0,    0,
  272,  104,    0,    0,    2,  280,    0,   34, 3621, 3653,
  297,   53,    0,    0,    0,    0,    0,    0,  313,    7,
    0,    0,    0,    0,    0,   74,    0,    0,    0,    0,
   74,    0,   74,    0,    0,    0,   74,   74,    0,    0,
   74,    0,   74,    0,    0, -302,  295, -302,    0,   97,
    0,    0,    0,    0,  130,    0,  130, 3667, 3681, 3695,
 3722, 3751, 3765, 4110,    0,   74,  326,  334,  106,  348,
  266,  131,    0,    0,    0,    0,    0,    0, 3834,    0,
   74,  355,  339,   74, -302,  360,   96,  113, 3802,   89,
    0, 3865,  -91,    0,  287,   74,  385, -198,  369,    0,
  392,    0,  372,    0, 1132, 3996,   74,    0,    0,  312,
   74,    0, -302,    0,    0,    0,    0,    0,  396,    0,
    0,    0,  398,  399,    0,    0,    0,    0,    0,    0,
  402,    0,    0,    0,    0,   12,  722,    0, 4027, 1132,
 4110,    0,   35,   64,   67,  -40,   74,   64,  260,    0,
    0,    0,    0, 1264,   74, -302,    0,  403,  421,  424,
  428,  429,  431,  436,  439,  442, 4066,  444,  445,  -20,
    0,   35,  372, 4110,    0,   98,    0,   36,   36,    0,
    0,   36,   36,    0,    0,    0,   64,    0,    0,    0,
  223,  447,  450,  451,  454,   -5,  434,    0,  458,  461,
  462,  464,   64, -302,   35,    0,    0,    0,    0,   50,
    0,    0,    0,
};
static const YYINT yyrindex[] = {                       506,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  174,  460,  460,  517,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  460,  460,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  523,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -218,    0, -218,    0,
  469,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  470,    0,    0,    0,    0,    0,    0,
  801,    0,    0,    0,    0,    0,    0,    0,    0, 3213,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -55,    0,    0,    0,    0,    0,    0,  471,
    0,    0,   68,  475,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1052, 1371, 1462, 1781, 1872, 2191, 3014, 3121,
    0, 2802, 2692, 2282, 2601,  642,  961,    0,    0,    0,
    0, -265,    0,    0,    0,    0,    0,  -53,    0,    0,
    0, -105,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -50,
    0,    0,    0,    0,  411,    0,  -92,    0,    0,    0,
    0,    0,    0, 3333,    0,    0,    0,    0,  477,    0,
    0, -115,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -76,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  414,    0,    0,
    0,    0,  632,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  873,    0,    0,    0,    0,    0,    0,
  -44,    0,  586,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   -7,  391,  710,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  839,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  586,    0,    0,    0,    0,    0,
    0,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
  103,    0,    0,   16,    0,  -59,  498, -414,    0,  357,
  323,    0,    0,   11,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -458,  192,    0,    0,    0,    0,    0,    0,  320,
   93,    0,  118,    0,    0,  510,  515,    0, -431,    0,
 -392,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  184,  408,  416,    1,    0,    0,    0,  101,  327,
    0,    0,  -15, -347,  508,    9,    0,   17,  -10,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  143,  278,
};
#define YYTABLESIZE 4451
static const YYINT yytable[] = {                        237,
   37,   79,   26,  131,   94,  133,  123,  164,  135,   82,
   36,  248,  177,  125,  328,   31,   25,  205,  121,   26,
  498,   79,   78,  500,   75,   81,  246,  254,  100,  482,
  162,  154,  462,  413,  240,  513,   79,  241,   98,   98,
   37,   85,   78,  252,   22,   96,  166,  328,   62,  462,
   36,  459,   23,   97,   57,   31,  522,   78,  151,  153,
  158,  158,  161,  153,  164,  165,  166,  168,   82,  458,
  172,  173,  181,  183,  184,   67,  515,   79,  170,  171,
  118,  252,   36,  185,   81,  191,  192,   31,   79,  252,
  523,   79,  466,   79,   58,  465,   98,   98,   78,  124,
   85,   59,   28,   72,  506,   79,  123,  152,   79,   78,
  478,  481,   78,  125,   78,   60,   22,  200,  121,   26,
  520,   61,  177,   63,   23,  152,   78,  243,  252,   78,
  241,  251,  499,  278,  252,  234,  252,  186,  279,   79,
  232,  230,   28,  231,  355,  233,  234,  241,   64,  481,
   65,  232,  238,  418,  419,   66,  233,  205,  499,   68,
   78,   69,  161,  238,   70,  481,  162,   71,  253,  168,
  234,  187,  499,   25,  176,  232,  230,   73,  231,   74,
  233,  189,  181,  195,  193,  194,  196,  197,  198,  199,
  200,  201,   36,  202,  203,  204,  274,   31,  276,  124,
  205,  206,  207,  164,  283,  284,  285,  131,  208,  133,
  289,  290,  291,  236,  209,  210,   21,  211,  212,  239,
  244,  249,  250,  131,  256,  133,  162,  473,  135,  258,
  102,  103,  104,  105,  227,  259,  164,  164,  106,  313,
  107,  269,  158,  108,  109,  110,  111,  131,   22,   22,
  257,  270,  316,  311,  271,   22,   23,   23,  321,  162,
  162,  112,  113,   23,  272,  114,  315,  115,  116,   86,
   87,  322,  117,  474,  475,  166,  166,   88,   89,   90,
   91,   92,   93,  118,  176,  119,  120,  330,  332,  317,
  334,  337,  339,  433,  468,  340,  344,  345,  346,  350,
  357,   79,  118,   22,  351,   22,   22,  352,  433,  468,
  118,   23,  354,   23,   23,   80,  122,   22,  323,  324,
   22,  325,   78,  358,  326,   23,   22,  327,   23,   26,
  102,  103,  104,  105,   23,   80,  359,  363,  106,  200,
  107,   22,  175,  108,  109,  110,  111,  200,  364,   23,
   80,  323,  324,  366,  325,  376,  375,  326,  377,  378,
  327,  112,  113,  433,  468,  114,  390,  115,  116,   21,
   76,   77,  117,  391,   21,   76,   77,  433,  468,  127,
  470,  471,   22,  118,  392,  119,  120,  394,  395,  396,
   23,   80,  380,   22,  400,  405,   22,  401,   22,  406,
  409,   23,   80,  405,   23,   80,   23,   80,  267,  415,
   22,  474,  475,   22,  407,  444,  122,  190,   23,   80,
   22,   23,   80,  452,  417,   36,  217,  218,   23,  421,
   31,  411,  422,  423,  450,  454,  194,  455,  456,  472,
  476,  457,  486,  213,   22,  214,  215,  444,  194,  194,
  444,  194,   23,   80,   81,   81,   81,   36,   81,   81,
   36,  487,   31,  488,  444,   31,  485,  489,   26,  490,
  476,  491,  502,  503,   36,  492,  504,  505,  493,   31,
   81,  175,  494,  459,  497,  507,   81,  509,   81,   81,
  510,  511,   81,   81,  512,  514,  260,   81,  516,  227,
  227,  517,  518,  263,  519,    2,   81,  227,  227,  227,
  227,  227,  227,   81,  521,  194,    1,  273,  224,  275,
   81,  277,   29,  280,  281,  282,  120,  203,  202,  286,
  287,  288,  155,  162,  479,  137,  169,  101,  268,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,  310,    2,  382,   29,
   29,  314,   29,   29,   29,   29,   29,   29,   29,   29,
  496,  469,  163,  433,  468,  159,  255,  247,  319,  320,
   29,   29,   29,  501,   29,   29,  414,   14,   15,  356,
  331,  188,  464,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   22,    0,    0,    0,
    0,    0,    0,    0,   23,   80,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   22,  200,    0,    0,    0,    0,    0,  174,   23,    0,
    0,    5,    0,    0,  200,   29,   29,   29,    0,    0,
    0,    0,    0,  194,    0,    0,    0,    0,  368,    0,
    0,    0,    0,  369,  194,  370,    0,    0,    0,  371,
  372,    0,    0,  373,    0,  374,    0,  194,    0,    5,
    0,    5,    5,    0,    5,    5,    5,    5,    0,  194,
  194,    0,  194,    0,  194,  194,    2,    0,  389,    5,
    5,    5,    0,    5,    5,    0,    0,    0,    0,    0,
  200,    0,    0,  399,    0,    0,  402,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   14,   15,  416,    0,
    0,    0,    0,    0,    0,    0,    0,  194,    0,  449,
    0,    0,    0,  451,  194,  194,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  199,  194,    0,    0,    0,
    0,    0,    0,   79,    5,    5,    5,   26,  199,   22,
    0,    0,    0,    0,    0,    0,  174,   23,    0,  477,
  436,    0,    0,   29,   78,    0,    0,  484,   29,    0,
   29,   29,    0,    0,    0,    0,   29,    0,   29,    0,
   29,    0,    0,   29,   29,    0,    0,   29,   29,   29,
    0,    0,   29,    0,    0,   29,    0,    0,   29,    0,
    0,    0,   29,   29,   29,   29,   29,   29,   29,   29,
   29,   29,    0,   29,  199,    0,   29,   29,    0,   29,
   29,    0,    0,   29,    0,   29,  461,    0,    0,    0,
   29,   29,   29,   29,   29,   29,    0,    0,  155,  200,
    0,  227,   29,   29,    0,    0,    0,    0,    0,   29,
    0,    0,    0,    0,    0,    0,   29,   29,   29,    0,
    0,    0,    0,    0,  196,    0,    0,    0,    0,  200,
  200,  123,    0,    0,    0,    0,  196,  196,  262,  196,
    0,    0,    5,  121,   26,  194,    0,    5,    0,    5,
    5,    0,  229,    0,    0,    5,    0,    5,    0,    5,
    0,    0,    5,    5,    0,    0,    5,    5,    5,    0,
  229,    5,  200,  227,    5,  194,  194,    5,    0,  200,
  200,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    0,    5,    0,    0,    5,    5,    0,    5,    5,
    6,    0,    5,  196,    5,    0,    0,    0,    0,    5,
    5,    5,    5,    5,    5,    0,    0,    0,  194,    0,
    0,    5,    5,  199,  124,  194,  194,  425,    5,  426,
  427,    0,    0,    0,    0,    5,    5,    5,    6,  428,
    6,    6,    0,    6,    6,    6,    6,    0,  429,    0,
    0,  430,    0,  199,  199,    0,    0,    0,    6,    6,
    6,    0,    6,    6,    0,   14,   15,  431,    0,    0,
    0,    0,  432,    0,    0,  433,  434,    0,  435,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   18,    0,    0,    0,    0,  199,    0,    0,    0,
    0,    0,    0,  199,  199,    0,    0,    0,   22,    0,
    0,    0,    0,    0,    0,    0,   23,   80,    0,    0,
    0,    0,    0,    6,    6,    6,    0,    0,    0,   18,
    0,   18,   18,    0,    0,   18,    0,   18,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   18,
   18,   18,  196,   18,   18,  102,  103,  104,  105,    0,
    0,    0,    0,  106,    0,  107,  227,  227,  108,  109,
  110,  111,    0,    0,  227,  227,  227,  227,  227,  227,
    0,    0,  196,  196,    0,    0,  112,  113,    0,    0,
  114,    0,  115,  116,    0,    0,    0,  117,    0,  234,
  227,    0,    0,    0,  232,  230,    0,  231,  118,  233,
  119,  120,    0,   79,   18,   18,   18,   26,    0,    0,
    0,    0,  229,    0,  228,  196,    0,    0,    0,    0,
  436,    0,  196,  196,   78,    0,    0,    0,  227,  227,
    0,  122,    0,    0,    0,   22,  227,  227,  227,  227,
  227,  227,    0,   23,    0,    0,    0,    0,    0,    0,
    0,    6,    0,    0,    0,    0,    6,    0,    6,    6,
    0,    0,    0,    0,    6,    0,    6,    0,    6,    0,
    0,    6,    6,    0,    0,    6,    6,    6,    0,    0,
    6,    0,    0,    6,    0,    0,    6,    0,    0,    0,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    0,    6,    0,    0,    6,    6,    0,    6,    6,    0,
    0,    6,    0,    6,    0,    0,    0,    0,    6,    6,
    6,    6,    6,    6,    0,    0,    0,    0,  234,  227,
    6,    6,  292,  232,  230,   79,  231,    6,  233,   26,
    0,    0,   18,    0,    6,    6,    6,   18,    0,   18,
   18,  229,  436,  228,  225,   18,   78,   18,    0,   18,
    0,    0,   18,   18,    0,    0,   18,   18,   18,    0,
    0,   18,    0,    0,   18,    0,    0,   18,    0,    0,
    0,   18,   18,   18,   18,   18,   18,   18,   18,   18,
   18,    0,   18,    0,    0,   18,   18,    0,   18,   18,
   19,    0,   18,    0,   18,    0,    0,    0,    0,   18,
   18,   18,   18,   18,   18,  226,    0,    0,  483,    0,
    0,   18,   18,    0,    0,    0,    0,  425,   18,  426,
  427,    0,    0,    0,    0,   18,   18,   18,   19,  428,
   19,   19,    0,    0,   19,    0,   19,    0,  429,    0,
    0,  430,    0,    0,    0,    0,    0,    0,   19,   19,
   19,    0,   19,   19,    0,   14,   15,  431,    0,    0,
    0,    0,  432,    0,    0,  433,  434,    0,  435,    0,
  217,  218,  219,  220,  221,  222,    0,    0,    0,    0,
    0,   14,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   22,    0,
    0,    0,    0,    0,    0,    0,   23,   80,    0,    0,
    0,    0,    0,   19,   19,   19,    0,    0,    0,   14,
    0,   14,   14,    0,    0,   14,    0,   14,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   14,
   14,   14,    0,   14,   14,    0,    0,    0,    0,  425,
    0,  426,  427,    0,    0,    0,    0,    0,    0,    0,
    0,  428,    0,    0,    0,    0,    0,    0,    0,    0,
  429,    0,    0,  430,    0,    0,  234,  227,    0,    0,
  335,  232,  230,  336,  231,    0,  233,   14,   15,  431,
    0,    0,    0,    0,  432,    0,    0,  433,  434,  229,
  435,  228,  225,    0,   14,   14,   14,    0,    0,  217,
  218,  219,  220,  221,  222,    0,    0,    0,    0,    0,
    0,  223,  224,  234,  227,    0,    0,  333,  232,  230,
   22,  231,    0,  233,    0,    0,    0,    0,   23,   80,
    0,    0,    0,    0,    0,    0,  229,    0,  228,  225,
    0,   19,    0,    0,    0,    0,   19,    0,   19,   19,
    0,    0,    0,  226,   19,    0,   19,    0,   19,    0,
    0,   19,   19,    0,    0,   19,   19,   19,    0,    0,
   19,    0,    0,   19,    0,    0,   19,    0,    0,    0,
   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
    0,   19,    0,    0,   19,   19,    0,   19,   19,    0,
  226,   19,    0,   19,    0,    0,    0,    0,   19,   19,
   19,   19,   19,   19,    0,    0,    0,    0,   26,    0,
   19,   19,    0,    0,    0,    0,    0,   19,    0,    0,
    0,   24,   14,    0,   19,   19,   19,   14,    0,   14,
   14,    0,    0,    0,    0,   14,    0,   14,    0,   14,
    0,    0,   14,   14,    0,    0,   14,   14,   14,    0,
    0,   14,    0,    0,   14,    0,    0,   14,    0,    0,
    0,   14,   14,   14,   14,   14,   14,   14,   14,   14,
   14,    0,   14,    0,    0,   14,   14,    0,   14,   14,
   15,    0,   14,    0,   14,   25,    0,    0,    0,    0,
    0,   14,   14,   14,   14,    0,    0,    0,    0,    0,
    0,   14,   14,    0,    0,    0,    0,    0,   14,    0,
    0,    0,    0,    0,    0,   14,   14,   14,   15,    0,
   15,   15,    0,    0,   15,    0,   15,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   15,   15,
   15,    0,   15,   15,    0,    0,    0,  217,  218,  219,
  220,  221,  222,    0,    0,    0,    0,    0,    0,  223,
  224,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   16,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  217,  218,  219,  220,  221,  222,
    0,    0,    0,   15,   15,   15,  223,  224,    0,   16,
    0,   16,   16,    0,    0,   16,    0,   16,    0,    0,
    0,    0,    0,    1,    0,    0,    0,    0,    0,   16,
   16,   16,    0,   16,   16,    0,    2,    0,    3,    0,
    0,    0,    0,    4,    5,    0,    0,    6,    7,    0,
    0,  234,    0,    0,    0,    8,  232,  230,    9,  231,
    0,  233,   10,   11,   12,   13,   14,   15,    0,   16,
   17,   18,    0,    0,  229,    0,  228,    0,    0,    0,
   19,  234,  227,   20,    0,   21,  232,  230,  235,  231,
    0,  233,    0,    0,   16,   16,   16,    0,    0,    0,
    0,    0,    0,    0,  229,    0,  228,  225,    0,   22,
    0,    0,    0,  234,  227,    0,    0,   23,  232,  230,
  341,  231,    0,  233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  229,    0,  228,  225,
    0,   15,    0,    0,    0,    0,   15,    0,   15,   15,
    0,    0,    0,    0,   15,    0,   15,    0,   15,    0,
    0,   15,   15,    0,    0,   15,   15,   15,  226,    0,
   15,    0,    0,   15,    0,    0,   15,    0,    0,    0,
   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
    0,   15,    0,    0,   15,   15,    0,   15,   15,    0,
  226,   15,    0,   15,    0,    0,    0,    0,    0,    0,
   15,   15,   15,   15,    0,    0,    0,    0,  234,  227,
   15,   15,  338,  232,  230,    0,  231,   15,  233,    0,
    0,    0,   16,    0,   15,   15,   15,   16,    0,   16,
   16,  229,    0,  228,  225,   16,    0,   16,    0,   16,
    0,    0,   16,   16,    0,    0,   16,   16,   16,    0,
    0,   16,    0,    0,   16,    0,    0,   16,    0,    0,
    0,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,    0,   16,    0,    0,   16,   16,    0,   16,   16,
   17,    0,   16,    0,   16,    0,    0,    0,    0,    0,
    0,   16,   16,   16,   16,  226,    0,    0,    0,    0,
    0,   16,   16,    0,    0,    0,    0,    0,   16,    0,
    0,    0,    0,    0,    0,   16,   16,   16,   17,    0,
   17,   17,    0,    0,   17,    0,   17,    0,    0,    0,
    0,    0,  217,  218,  219,  220,  221,  222,   17,   17,
   17,    0,   17,   17,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  217,  218,  219,  220,  221,  222,    0,    0,
    0,   12,    0,    0,  223,  224,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  217,  218,  219,  220,  221,  222,
    0,    0,    0,   17,   17,   17,  223,  224,    0,   12,
    0,   12,   12,    0,    0,   12,    0,   12,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   12,
   12,   12,    0,   12,   12,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  234,  227,    0,    0,  342,  232,  230,    0,  231,
    0,  233,    0,    0,    0,  234,  227,    0,    0,    0,
  232,  230,  343,  231,  229,  233,  228,  225,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  229,    0,
  228,  225,    0,    0,   12,   12,   12,    0,    0,  217,
  218,  219,  220,  221,  222,    0,    0,    0,    0,  234,
  227,  223,  224,    0,  232,  230,    0,  231,    0,  233,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  229,    0,  228,    0,    0,    0,  226,    0,
    0,   17,    0,    0,    0,    0,   17,    0,   17,   17,
    0,    0,  226,    0,   17,    0,   17,    0,   17,    0,
    0,   17,   17,    0,    0,   17,   17,   17,    0,    0,
   17,    0,    0,   17,    0,    0,   17,    0,    0,    0,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
    0,   17,    0,    0,   17,   17,  226,   17,   17,    0,
    0,   17,    0,   17,    0,    0,    0,    0,    0,    0,
   17,   17,   17,   17,    0,    0,    0,    0,  234,  227,
   17,   17,    0,  232,  230,  347,  231,   17,  233,    0,
    0,    0,   12,    0,   17,   17,   17,   12,    0,   12,
   12,  229,    0,  228,  225,   12,    0,   12,    0,   12,
    0,    0,   12,   12,    0,    0,   12,   12,   12,    0,
    0,   12,    0,    0,   12,    0,    0,   12,    0,    0,
    0,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,    0,   12,    0,    0,   12,   12,    0,   12,   12,
   13,    0,   12,    0,   12,    0,    0,    0,    0,    0,
    0,   12,   12,   12,   12,  226,    0,    0,    0,    0,
    0,   12,   12,    0,    0,    0,    0,    0,   12,    0,
    0,    0,    0,    0,    0,   12,   12,   12,   13,    0,
   13,   13,    0,    0,   13,    0,   13,    0,    0,    0,
    0,    0,  217,  218,  219,  220,  221,  222,   13,   13,
   13,    0,   13,   13,  223,  224,  217,  218,  219,  220,
  221,  222,    0,    0,    0,    0,    0,    0,  223,  224,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   10,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  217,  218,  219,  220,  221,  222,    0,    0,    0,    0,
    0,    0,  223,   13,   13,   13,    0,    0,    0,   10,
    0,   10,   10,    0,    0,   10,    0,   10,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,
   10,    0,    0,    0,   10,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   11,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   10,   10,   10,    0,    0,  217,
  218,  219,  220,  221,  222,    0,    0,    0,    0,    0,
    0,  223,  224,    0,    0,    0,    0,    0,    0,    0,
    0,   11,   11,    0,    0,   11,    0,   11,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   11,
   11,   13,    0,    0,   11,    0,   13,    0,   13,   13,
    0,    0,    0,    0,   13,    0,   13,    0,   13,    0,
    0,   13,   13,    0,    0,   13,   13,   13,    0,    0,
   13,    0,    0,   13,    0,    0,   13,    0,    0,    0,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
    0,   13,    0,    0,   13,   13,    0,   13,   13,    0,
    0,   13,    0,   13,   11,   11,   11,    0,    0,    0,
   13,   13,   13,   13,    0,    0,    0,    0,  234,  227,
   13,   13,    0,  232,  230,  348,  231,   13,  233,    0,
    0,    0,   10,    0,   13,   13,   13,   10,    0,   10,
   10,  229,    0,  228,  225,   10,    0,   10,    0,   10,
    0,    0,   10,   10,    0,    0,   10,   10,   10,    0,
    0,   10,    0,    0,   10,    0,    0,   10,    0,    0,
    0,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,    0,   10,    0,    0,   10,   10,    0,   10,   10,
    0,    0,   10,   20,   10,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  226,    0,    0,    0,    0,
    0,   10,   10,    0,    0,    0,    0,    0,   10,    0,
    0,    0,    0,    0,    0,   10,   10,   10,    0,    0,
    0,    0,    0,   20,   20,    0,    0,   20,    0,   20,
    0,    0,   11,    0,    0,    0,    0,   11,    0,   11,
   11,   20,   20,    0,    0,   11,   20,   11,    0,   11,
    0,    0,   11,   11,    0,    0,   11,   11,   11,    0,
    0,   11,    0,    0,   11,    0,    0,   11,    0,    0,
    0,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,    0,   11,    0,    0,   11,   11,    0,   11,   11,
   21,    0,   11,    0,   11,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   20,    0,   20,    0,
    0,   11,   11,    0,    0,    0,    0,    0,   11,    0,
    0,    0,    0,    0,    0,   11,   11,   11,    0,    0,
   21,   21,    0,    0,   21,    0,   21,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   21,   21,
    0,    0,    0,   21,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   96,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  217,
  218,  219,  220,  221,  222,    0,    0,    0,    0,    0,
    0,  223,  224,   21,    0,   21,    0,    0,    0,    0,
    0,    0,   96,   96,    0,    0,   96,    0,   96,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   96,   96,    0,    0,   20,    0,    0,    0,    0,   20,
    0,   20,   20,    0,    0,    0,    0,   20,    0,   20,
    0,   20,    0,    0,   20,   20,    0,    0,   20,   20,
   20,    0,    0,   20,    0,    0,   20,    0,    0,   20,
    0,    0,    0,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,    0,   20,    0,    0,   20,   20,    0,
   20,   20,   25,    0,   20,   96,   20,   96,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,   20,    0,    0,    0,    0,    0,
   20,    0,    0,    0,    0,    0,    0,   20,   20,   20,
    0,    0,   25,   25,    0,    0,   25,    0,   25,    0,
    0,   21,    0,    0,    0,    0,   21,    0,   21,   21,
   25,   25,    0,    0,   21,    0,   21,    0,   21,    0,
    0,   21,   21,    0,    0,   21,   21,   21,    0,    0,
   21,    0,    0,   21,    0,    0,   21,    0,    0,    0,
   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
    0,   21,    0,    0,   21,   21,    0,   21,   21,    0,
    0,   21,    0,   21,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   25,    0,   25,    0,    0,
    0,   21,    0,    0,    0,    0,    0,   21,    0,    0,
    0,    0,    0,   96,   21,   21,   21,    0,   96,    0,
   96,   96,    0,    0,    0,    0,   96,    0,   96,    0,
   96,    0,    0,   96,   96,    0,    0,   96,   96,   96,
    0,    0,   96,    0,    0,   96,    0,    0,   96,    0,
    0,    0,   96,   96,   96,   96,   96,   96,   96,   96,
   96,   96,    0,   96,    0,    0,   96,   96,    0,   96,
   96,    0,    0,   96,    0,   96,    0,  234,  227,    0,
    0,  349,  232,  230,    0,  231,    0,  233,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   96,
  229,    0,  228,  225,  234,  227,   96,   96,   96,  232,
  230,    0,  231,    0,  233,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  353,    0,  229,    0,  228,
  225,    0,    0,   25,    0,    0,    0,    0,   25,    0,
   25,   25,    0,    0,    0,    0,   25,    0,   25,    0,
   25,    0,    0,   25,   25,    0,    0,   25,   25,   25,
    0,    0,   25,    0,  226,   25,    0,    0,   25,    0,
    0,    0,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   25,    0,   25,    0,    0,   25,   25,    0,   25,
   25,  226,    0,   25,    0,   25,    0,  234,  227,    0,
    0,  361,  232,  230,    0,  231,    0,  233,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   25,
  229,    0,  228,  225,    0,    0,   25,   25,   25,  234,
  227,    0,    0,  362,  232,  230,    0,  231,    0,  233,
    0,    0,    0,  234,  227,    0,    0,  383,  232,  230,
    0,  231,  229,  233,  228,  225,    0,  234,  227,    0,
    0,  384,  232,  230,    0,  231,  229,  233,  228,  225,
    0,  234,  227,    0,    0,  385,  232,  230,    0,  231,
  229,  233,  228,  225,  226,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  229,    0,  228,  225,  234,  227,
    0,    0,  386,  232,  230,    0,  231,    0,  233,    0,
    0,    0,    0,    0,    0,    0,  226,    0,    0,    0,
    0,  229,    0,  228,  225,    0,    0,  234,  227,    0,
  226,  387,  232,  230,    0,  231,    0,  233,    0,    0,
    0,  234,  227,    0,  226,  388,  232,  230,    0,  231,
  229,  233,  228,  225,    0,    0,    0,    0,  226,    0,
    0,    0,    0,    0,  229,    0,  228,  225,  217,  218,
  219,  220,  221,  222,    0,    0,    0,    0,  234,  227,
  223,  224,  410,  232,  230,  226,  231,    0,  233,    0,
    0,    0,    0,    0,    0,  217,  218,  219,  220,  221,
  222,  229,    0,  228,  225,    0,    0,  223,  224,    0,
  234,  227,    0,    0,  226,  232,  230,  398,  231,    0,
  233,    0,    0,    0,    0,    0,    0,    0,  226,    0,
    0,    0,    0,  229,    0,  228,  225,    0,    0,    0,
    0,  234,  227,    0,    0,  412,  232,  230,    0,  231,
    0,  233,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  229,  226,  228,  225,    0,    0,
    0,  234,  227,    0,    0,    0,  232,  230,    0,  231,
    0,  233,    0,    0,    0,    0,    0,    0,  217,  218,
  219,  220,  221,  222,  229,    0,  228,  226,    0,    0,
  223,  224,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  217,  218,  219,  220,  221,  222,    0,    0,  226,    0,
    0,    0,  223,  224,  217,  218,  219,  220,  221,  222,
    0,    0,    0,    0,    0,    0,  223,  224,  217,  218,
  219,  220,  221,  222,    0,    0,    0,    0,  226,    0,
  223,  224,  217,  218,  219,  220,  221,  222,    0,    0,
    0,    0,  234,  227,  223,  224,  448,  232,  230,    0,
  231,    0,  233,    0,    0,    0,    0,    0,    0,  217,
  218,  219,  220,  221,  222,  229,    0,  228,  225,    0,
    0,  223,  224,  234,  227,    0,    0,  463,  232,  230,
    0,  231,    0,  233,    0,    0,    0,    0,  217,  218,
  219,  220,  221,  222,    0,    0,  229,    0,  228,  225,
  223,  224,  217,  218,  219,  220,  221,  222,    0,    0,
    0,    0,  234,  227,  223,  224,  495,  232,  230,    0,
  231,    0,  233,    0,    0,    0,    0,    0,    0,  226,
    0,    0,    0,    0,    0,  229,    0,  228,  225,  217,
  218,  219,  220,  221,  222,    0,    0,    0,    0,    0,
    0,  223,  224,    0,    0,    0,  234,  227,    0,    0,
  226,  232,  230,    0,  231,    0,  233,    0,    0,    0,
    0,  217,  218,  219,  220,  221,  222,    0,    0,  229,
    0,  228,  225,  223,  224,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  226,
    0,    0,  217,  218,  219,  220,  221,  222,    0,    0,
    0,    0,    0,    0,  223,  224,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  217,  218,  219,  220,  221,  222,    0,    0,
    0,    0,    0,  226,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  217,  218,  219,  220,  221,  222,    0,
    0,    0,    0,    0,    0,  223,  224,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  217,  218,  219,  220,  221,  222,
    0,    0,    0,    0,    0,    0,  223,  224,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  217,  218,  219,  220,  221,  222,    0,
    0,    0,    0,    0,    0,  223,  224,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  217,  218,  219,
  220,  221,  222,    0,    0,    0,    0,    0,    0,  223,
  224,
};
static const YYINT yycheck[] = {                         41,
    0,   42,   46,   59,   61,   59,   33,  123,   59,   25,
    0,   41,   72,   40,   41,    0,  123,  123,   45,   46,
   41,   42,   63,  482,  355,   25,  125,  125,   39,  461,
  123,  262,  447,  125,   41,   41,   42,   44,   38,   39,
   40,   25,   63,  262,  347,   37,  123,   41,  123,  464,
   40,   40,  355,   37,   40,   40,  515,   63,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,   84,   58,
   70,   71,   72,   73,   74,  123,  508,   42,   68,   69,
  125,  347,   72,   75,   84,   96,   97,   72,   42,  355,
   41,   42,   58,   42,   40,   61,   96,   97,   63,  126,
   84,   40,    0,  123,  497,   42,   33,   40,   42,   63,
  458,  459,   63,   40,   63,   40,  347,  125,   45,   46,
  513,   40,  182,   40,  355,   58,   63,   41,  347,   63,
   44,   41,  480,  344,   44,   37,  355,   59,  349,   42,
   42,   43,   40,   45,   41,   47,   37,   44,   40,  497,
   40,   42,  152,  352,  353,   40,   47,  263,  506,   40,
   63,   40,  162,  163,   40,  513,  259,   40,  168,  169,
   37,  125,  520,  123,   72,   42,   43,   40,   45,   40,
   47,   59,  182,   40,   59,   59,   40,   40,   40,   40,
   40,   40,  182,   40,   40,   40,  196,  182,  198,  126,
   40,   40,   40,  319,  204,  205,  206,  263,   40,  263,
  210,  211,  212,   41,   40,   40,  323,   40,   40,   40,
  350,   41,   41,  279,   61,  279,  319,  268,  279,   44,
  257,  258,  259,  260,   61,   41,  352,  353,  265,  239,
  267,   41,  242,  270,  271,  272,  273,  303,  347,  347,
   61,   41,  252,  355,   59,  347,  355,  355,  258,  352,
  353,  288,  289,  355,   59,  292,   58,  294,  295,  326,
  327,   58,  299,  314,  315,  352,  353,  334,  335,  336,
  337,  338,  339,  310,  182,  312,  313,   40,   58,  277,
   41,   41,   41,  314,  315,   41,   41,   41,   41,   41,
  299,   42,  347,  347,   44,  347,  347,   41,  314,  315,
  355,  355,   41,  355,  355,  356,  343,  347,  345,  346,
  347,  348,   63,   44,  351,  355,  347,  354,  355,   46,
  257,  258,  259,  260,  355,  356,  303,   41,  265,  347,
  267,  347,   59,  270,  271,  272,  273,  355,  296,  355,
  356,  345,  346,   41,  348,   61,  356,  351,  358,  263,
  354,  288,  289,  314,  315,  292,   41,  294,  295,  323,
  324,  325,  299,   40,  323,  324,  325,  314,  315,   57,
  314,  315,  347,  310,  279,  312,  313,   40,  123,  259,
  355,  356,  263,  347,   40,  395,  347,   59,  347,   40,
  288,  355,  356,  403,  355,  356,  355,  356,  125,  123,
  347,  314,  315,  347,  319,  415,  343,   95,  355,  356,
  347,  355,  356,  423,   40,  415,  328,  329,  355,   61,
  415,  343,   41,   62,  123,   40,   46,   40,   40,  455,
  456,   40,   40,  121,  347,  123,  124,  447,   58,   59,
  450,   61,  355,  356,  454,  455,  456,  447,  458,  459,
  450,   41,  447,   40,  464,  450,  466,   40,   46,   41,
  486,   41,  488,  489,  464,   40,  492,  493,   40,  464,
  480,   59,   41,   40,   40,  263,  486,   41,  488,  489,
   41,   41,  492,  493,   41,   62,  174,  497,   41,  326,
  327,   41,   41,  181,   41,    0,  506,  334,  335,  336,
  337,  338,  339,  513,  514,  125,    0,  195,   59,  197,
  520,  199,    0,  201,  202,  203,   58,   58,   58,  207,
  208,  209,   58,  123,  275,   59,  123,   40,  182,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  274,  367,   37,
   38,  242,   40,   41,   42,   43,   44,   45,   46,   47,
  478,  454,   63,  314,  315,   61,  169,  162,  256,  257,
   58,   59,   60,  483,   62,   63,  403,  304,  305,  312,
  264,   84,  450,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  355,  356,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  347,   46,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,
   -1,    0,   -1,   -1,   59,  123,  124,  125,   -1,   -1,
   -1,   -1,   -1,  263,   -1,   -1,   -1,   -1,  336,   -1,
   -1,   -1,   -1,  341,  274,  343,   -1,   -1,   -1,  347,
  348,   -1,   -1,  351,   -1,  353,   -1,   46,   -1,   38,
   -1,   40,   41,   -1,   43,   44,   45,   46,   -1,   58,
   59,   -1,   61,   -1,  304,  305,  274,   -1,  376,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
  125,   -1,   -1,  391,   -1,   -1,  394,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  304,  305,  406,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  347,   -1,  417,
   -1,   -1,   -1,  421,  354,  355,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   46,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   42,  123,  124,  125,   46,   59,  347,
   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,   -1,  457,
   59,   -1,   -1,  261,   63,   -1,   -1,  465,  266,   -1,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,
  278,   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,
   -1,   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,
   -1,   -1,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,   -1,  311,  125,   -1,  314,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,  323,  125,   -1,   -1,   -1,
  328,  329,  330,  331,  332,  333,   -1,   -1,   58,  274,
   -1,   61,  340,  341,   -1,   -1,   -1,   -1,   -1,  347,
   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,  356,   -1,
   -1,   -1,   -1,   -1,   46,   -1,   -1,   -1,   -1,  304,
  305,   33,   -1,   -1,   -1,   -1,   58,   59,   40,   61,
   -1,   -1,  261,   45,   46,  274,   -1,  266,   -1,  268,
  269,   -1,   40,   -1,   -1,  274,   -1,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   58,  290,  347,   61,  293,  304,  305,  296,   -1,  354,
  355,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
    0,   -1,  321,  125,  323,   -1,   -1,   -1,   -1,  328,
  329,  330,  331,  332,  333,   -1,   -1,   -1,  347,   -1,
   -1,  340,  341,  274,  126,  354,  355,  266,  347,  268,
  269,   -1,   -1,   -1,   -1,  354,  355,  356,   38,  278,
   40,   41,   -1,   43,   44,   45,   46,   -1,  287,   -1,
   -1,  290,   -1,  304,  305,   -1,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   -1,  304,  305,  306,   -1,   -1,
   -1,   -1,  311,   -1,   -1,  314,  315,   -1,  317,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  347,   -1,   -1,   -1,
   -1,   -1,   -1,  354,  355,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,   -1,   -1,
   -1,   -1,   -1,  123,  124,  125,   -1,   -1,   -1,   38,
   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,  274,   62,   63,  257,  258,  259,  260,   -1,
   -1,   -1,   -1,  265,   -1,  267,  326,  327,  270,  271,
  272,  273,   -1,   -1,  334,  335,  336,  337,  338,  339,
   -1,   -1,  304,  305,   -1,   -1,  288,  289,   -1,   -1,
  292,   -1,  294,  295,   -1,   -1,   -1,  299,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,  310,   47,
  312,  313,   -1,   42,  123,  124,  125,   46,   -1,   -1,
   -1,   -1,   60,   -1,   62,  347,   -1,   -1,   -1,   -1,
   59,   -1,  354,  355,   63,   -1,   -1,   -1,  326,  327,
   -1,  343,   -1,   -1,   -1,  347,  334,  335,  336,  337,
  338,  339,   -1,  355,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,  278,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,  328,  329,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,   37,   38,
  340,  341,   41,   42,   43,   42,   45,  347,   47,   46,
   -1,   -1,  261,   -1,  354,  355,  356,  266,   -1,  268,
  269,   60,   59,   62,   63,  274,   63,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
    0,   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,  328,
  329,  330,  331,  332,  333,  124,   -1,   -1,  125,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,  266,  347,  268,
  269,   -1,   -1,   -1,   -1,  354,  355,  356,   38,  278,
   40,   41,   -1,   -1,   44,   -1,   46,   -1,  287,   -1,
   -1,  290,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   -1,  304,  305,  306,   -1,   -1,
   -1,   -1,  311,   -1,   -1,  314,  315,   -1,  317,   -1,
  328,  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  355,  356,   -1,   -1,
   -1,   -1,   -1,  123,  124,  125,   -1,   -1,   -1,   38,
   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,  266,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  278,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  287,   -1,   -1,  290,   -1,   -1,   37,   38,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,  304,  305,  306,
   -1,   -1,   -1,   -1,  311,   -1,   -1,  314,  315,   60,
  317,   62,   63,   -1,  123,  124,  125,   -1,   -1,  328,
  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,   -1,
   -1,  340,  341,   37,   38,   -1,   -1,   41,   42,   43,
  347,   45,   -1,   47,   -1,   -1,   -1,   -1,  355,  356,
   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,   63,
   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,  268,  269,
   -1,   -1,   -1,  124,  274,   -1,  276,   -1,  278,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,   -1,
  124,  321,   -1,  323,   -1,   -1,   -1,   -1,  328,  329,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,   46,   -1,
  340,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,
   -1,   59,  261,   -1,  354,  355,  356,  266,   -1,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
    0,   -1,  321,   -1,  323,  123,   -1,   -1,   -1,   -1,
   -1,  330,  331,  332,  333,   -1,   -1,   -1,   -1,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,  356,   38,   -1,
   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   -1,   -1,   -1,  328,  329,  330,
  331,  332,  333,   -1,   -1,   -1,   -1,   -1,   -1,  340,
  341,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  328,  329,  330,  331,  332,  333,
   -1,   -1,   -1,  123,  124,  125,  340,  341,   -1,   38,
   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,
   -1,   -1,   -1,  261,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,  274,   -1,  276,   -1,
   -1,   -1,   -1,  281,  282,   -1,   -1,  285,  286,   -1,
   -1,   37,   -1,   -1,   -1,  293,   42,   43,  296,   45,
   -1,   47,  300,  301,  302,  303,  304,  305,   -1,  307,
  308,  309,   -1,   -1,   60,   -1,   62,   -1,   -1,   -1,
  318,   37,   38,  321,   -1,  323,   42,   43,   44,   45,
   -1,   47,   -1,   -1,  123,  124,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   -1,   62,   63,   -1,  347,
   -1,   -1,   -1,   37,   38,   -1,   -1,  355,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,   63,
   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,  278,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,  124,   -1,
  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,   -1,
  124,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,   37,   38,
  340,  341,   41,   42,   43,   -1,   45,  347,   47,   -1,
   -1,   -1,  261,   -1,  354,  355,  356,  266,   -1,  268,
  269,   60,   -1,   62,   63,  274,   -1,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
    0,   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,  330,  331,  332,  333,  124,   -1,   -1,   -1,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,  356,   38,   -1,
   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,   -1,
   -1,   -1,  328,  329,  330,  331,  332,  333,   58,   59,
   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  328,  329,  330,  331,  332,  333,   -1,   -1,
   -1,    0,   -1,   -1,  340,  341,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  328,  329,  330,  331,  332,  333,
   -1,   -1,   -1,  123,  124,  125,  340,  341,   -1,   38,
   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   37,   38,   -1,   -1,   -1,
   42,   43,   44,   45,   60,   47,   62,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   60,   -1,
   62,   63,   -1,   -1,  123,  124,  125,   -1,   -1,  328,
  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,   37,
   38,  340,  341,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   60,   -1,   62,   -1,   -1,   -1,  124,   -1,
   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,  268,  269,
   -1,   -1,  124,   -1,  274,   -1,  276,   -1,  278,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,   -1,   -1,  314,  315,  124,  317,  318,   -1,
   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,   37,   38,
  340,  341,   -1,   42,   43,   44,   45,  347,   47,   -1,
   -1,   -1,  261,   -1,  354,  355,  356,  266,   -1,  268,
  269,   60,   -1,   62,   63,  274,   -1,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
    0,   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,  330,  331,  332,  333,  124,   -1,   -1,   -1,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,  356,   38,   -1,
   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,   -1,
   -1,   -1,  328,  329,  330,  331,  332,  333,   58,   59,
   60,   -1,   62,   63,  340,  341,  328,  329,  330,  331,
  332,  333,   -1,   -1,   -1,   -1,   -1,   -1,  340,  341,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  328,  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,
   -1,   -1,  340,  123,  124,  125,   -1,   -1,   -1,   38,
   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  123,  124,  125,   -1,   -1,  328,
  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,  261,   -1,   -1,   63,   -1,  266,   -1,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,  278,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,  323,  123,  124,  125,   -1,   -1,   -1,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,   37,   38,
  340,  341,   -1,   42,   43,   44,   45,  347,   47,   -1,
   -1,   -1,  261,   -1,  354,  355,  356,  266,   -1,  268,
  269,   60,   -1,   62,   63,  274,   -1,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
   -1,   -1,  321,    0,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,   -1,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,  356,   -1,   -1,
   -1,   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   46,
   -1,   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,  268,
  269,   58,   59,   -1,   -1,  274,   63,  276,   -1,  278,
   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,
   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,
    0,   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,
   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,
   -1,   -1,   -1,   -1,   -1,  354,  355,  356,   -1,   -1,
   40,   41,   -1,   -1,   44,   -1,   46,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,
  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,   -1,
   -1,  340,  341,  123,   -1,  125,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   -1,   -1,  261,   -1,   -1,   -1,   -1,  266,
   -1,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,  276,
   -1,  278,   -1,   -1,  281,  282,   -1,   -1,  285,  286,
  287,   -1,   -1,  290,   -1,   -1,  293,   -1,   -1,  296,
   -1,   -1,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,   -1,  311,   -1,   -1,  314,  315,   -1,
  317,  318,    0,   -1,  321,  123,  323,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  340,  341,   -1,   -1,   -1,   -1,   -1,
  347,   -1,   -1,   -1,   -1,   -1,   -1,  354,  355,  356,
   -1,   -1,   40,   41,   -1,   -1,   44,   -1,   46,   -1,
   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,  268,  269,
   58,   59,   -1,   -1,  274,   -1,  276,   -1,  278,   -1,
   -1,  281,  282,   -1,   -1,  285,  286,  287,   -1,   -1,
  290,   -1,   -1,  293,   -1,   -1,  296,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
   -1,  311,   -1,   -1,  314,  315,   -1,  317,  318,   -1,
   -1,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,  125,   -1,   -1,
   -1,  341,   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,
   -1,   -1,   -1,  261,  354,  355,  356,   -1,  266,   -1,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,
  278,   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,
   -1,   -1,  290,   -1,   -1,  293,   -1,   -1,  296,   -1,
   -1,   -1,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,
  318,   -1,   -1,  321,   -1,  323,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  347,
   60,   -1,   62,   63,   37,   38,  354,  355,  356,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   60,   -1,   62,
   63,   -1,   -1,  261,   -1,   -1,   -1,   -1,  266,   -1,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,  276,   -1,
  278,   -1,   -1,  281,  282,   -1,   -1,  285,  286,  287,
   -1,   -1,  290,   -1,  124,  293,   -1,   -1,  296,   -1,
   -1,   -1,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,   -1,  311,   -1,   -1,  314,  315,   -1,  317,
  318,  124,   -1,  321,   -1,  323,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  347,
   60,   -1,   62,   63,   -1,   -1,  354,  355,  356,   37,
   38,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   60,   47,   62,   63,   -1,   37,   38,   -1,
   -1,   41,   42,   43,   -1,   45,   60,   47,   62,   63,
   -1,   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,
   60,   47,   62,   63,  124,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   -1,   62,   63,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,   -1,
   -1,   60,   -1,   62,   63,   -1,   -1,   37,   38,   -1,
  124,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   37,   38,   -1,  124,   41,   42,   43,   -1,   45,
   60,   47,   62,   63,   -1,   -1,   -1,   -1,  124,   -1,
   -1,   -1,   -1,   -1,   60,   -1,   62,   63,  328,  329,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,   37,   38,
  340,  341,   41,   42,   43,  124,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,  328,  329,  330,  331,  332,
  333,   60,   -1,   62,   63,   -1,   -1,  340,  341,   -1,
   37,   38,   -1,   -1,  124,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,
   -1,   -1,   -1,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   37,   38,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   60,  124,   62,   63,   -1,   -1,
   -1,   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  328,  329,
  330,  331,  332,  333,   60,   -1,   62,  124,   -1,   -1,
  340,  341,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  328,  329,  330,  331,  332,  333,   -1,   -1,  124,   -1,
   -1,   -1,  340,  341,  328,  329,  330,  331,  332,  333,
   -1,   -1,   -1,   -1,   -1,   -1,  340,  341,  328,  329,
  330,  331,  332,  333,   -1,   -1,   -1,   -1,  124,   -1,
  340,  341,  328,  329,  330,  331,  332,  333,   -1,   -1,
   -1,   -1,   37,   38,  340,  341,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  328,
  329,  330,  331,  332,  333,   60,   -1,   62,   63,   -1,
   -1,  340,  341,   37,   38,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,  328,  329,
  330,  331,  332,  333,   -1,   -1,   60,   -1,   62,   63,
  340,  341,  328,  329,  330,  331,  332,  333,   -1,   -1,
   -1,   -1,   37,   38,  340,  341,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   60,   -1,   62,   63,  328,
  329,  330,  331,  332,  333,   -1,   -1,   -1,   -1,   -1,
   -1,  340,  341,   -1,   -1,   -1,   37,   38,   -1,   -1,
  124,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,  328,  329,  330,  331,  332,  333,   -1,   -1,   60,
   -1,   62,   63,  340,  341,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,  328,  329,  330,  331,  332,  333,   -1,   -1,
   -1,   -1,   -1,   -1,  340,  341,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  328,  329,  330,  331,  332,  333,   -1,   -1,
   -1,   -1,   -1,  124,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  328,  329,  330,  331,  332,  333,   -1,
   -1,   -1,   -1,   -1,   -1,  340,  341,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  328,  329,  330,  331,  332,  333,
   -1,   -1,   -1,   -1,   -1,   -1,  340,  341,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  328,  329,  330,  331,  332,  333,   -1,
   -1,   -1,   -1,   -1,   -1,  340,  341,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,  329,  330,
  331,  332,  333,   -1,   -1,   -1,   -1,   -1,   -1,  340,
  341,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 27
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 356
#define YYUNDFTOKEN 461
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'!'",0,
0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,
0,0,0,"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error","T_ABSOLUTE","T_ADDR",
"T_ALIGN","T_ALIGNOF","T_ASSERT","T_AS_NEEDED","T_AT","T_BIND","T_BLOCK",
"T_BYTE","T_CONSTANT","T_CONSTRUCTORS","T_CREATE_OBJECT_SYMBOLS",
"T_DATA_SEGMENT_ALIGN","T_DATA_SEGMENT_END","T_DATA_SEGMENT_RELRO_END",
"T_DEFINED","T_ENTRY","T_EXCLUDE_FILE","T_EXTERN","T_FILEHDR","T_FILL",
"T_FLAGS","T_FLOAT","T_FORCE_COMMON_ALLOCATION","T_GROUP","T_HLL","T_INCLUDE",
"T_INHIBIT_COMMON_ALLOCATION","T_INPUT","T_KEEP","T_LENGTH","T_LOADADDR",
"T_LONG","T_MAP","T_MAX","T_MEMORY","T_MIN","T_NEXT","T_NOCROSSREFS",
"T_NOFLOAT","T_OPTION","T_ORIGIN","T_OUTPUT","T_OUTPUT_ARCH","T_OUTPUT_FORMAT",
"T_PHDRS","T_PROVIDE","T_PROVIDE_HIDDEN","T_QUAD","T_REGION_ALIAS",
"T_SEARCH_DIR","T_SECTIONS","T_SEGMENT_START","T_SHORT","T_SIZEOF",
"T_SIZEOF_HEADERS","T_SORT_BY_ALIGNMENT","T_SORT_BY_NAME","T_SPECIAL","T_SQUAD",
"T_STARTUP","T_SUBALIGN","T_SYSLIB","T_TARGET","T_TRUNCATE","T_VER_EXTERN",
"T_VER_GLOBAL","T_VER_LOCAL","T_LSHIFT_E","T_RSHIFT_E","T_LSHIFT","T_RSHIFT",
"T_EQ","T_NE","T_GE","T_LE","T_ADD_E","T_SUB_E","T_MUL_E","T_DIV_E","T_AND_E",
"T_OR_E","T_LOGICAL_AND","T_LOGICAL_OR","UNARY","T_NUM","T_COMMONPAGESIZE",
"T_COPY","T_DSECT","T_IDENT","T_INFO","T_MAXPAGESIZE","T_MEMORY_ATTR",
"T_NOLOAD","T_ONLY_IF_RO","T_ONLY_IF_RW","T_OVERLAY","T_STRING","T_WILDCARD",
"$accept","script","assignment","provide_assignment",
"provide_hidden_assignment","simple_assignment","assert_command",
"entry_command","ldscript_command","output_section_command","sections_command",
"sections_sub_command","expression","function","constant","variable",
"absolute_function","addr_function","align_function","alignof_function",
"block_function","data_segment_align_function","data_segment_end_function",
"data_segment_relro_end_function","defined_function","length_function",
"loadaddr_function","max_function","min_function","next_function",
"origin_function","output_section_addr","output_section_align",
"output_section_fillexp","output_section_lma","output_section_subalign",
"overlay_vma","phdr_at","segment_start_function","sizeof_function",
"sizeof_headers_function","input_file","input_section","input_section_desc",
"input_section_desc_no_keep","as_needed_list","ident_list","ident_list_nosep",
"input_file_list","output_section_addr_and_type","output_section_phdr",
"overlay_section_list","wildcard_list","assign_op","data_type",
"output_section_keywords","overlay_nocref","phdr_filehdr","phdr_flags",
"phdr_phdrs","output_section_data","output_sections_desc","overlay_desc",
"overlay_section","phdr","memory_region","ident","memory_attr",
"output_section_constraint","output_section_lma_region","output_section_region",
"output_section_type","output_section_type_keyword","symbolic_constant",
"wildcard","wildcard_sort","version_entry","version_block","version_entry_list",
"extern_block","version_dependency","ldscript","extern_command",
"force_common_allocation_command","group_command",
"inhibit_common_allocation_command","input_command","memory_command",
"nocrossrefs_command","output_command","output_arch_command",
"output_format_command","phdrs_command","region_alias_command",
"search_dir_command","startup_command","target_command","version_script_node",
"memory_region_list","phdr_list","sections_command_list","$$1",
"output_section_command_list","separator","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : script",
"script : ldscript",
"script :",
"ldscript : ldscript_command",
"ldscript : ldscript ldscript_command",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : expression '*' expression",
"expression : expression '/' expression",
"expression : expression '%' expression",
"expression : expression '&' expression",
"expression : expression '|' expression",
"expression : expression '>' expression",
"expression : expression '<' expression",
"expression : expression T_EQ expression",
"expression : expression T_NE expression",
"expression : expression T_GE expression",
"expression : expression T_LE expression",
"expression : expression T_LSHIFT expression",
"expression : expression T_RSHIFT expression",
"expression : expression T_LOGICAL_AND expression",
"expression : expression T_LOGICAL_OR expression",
"expression : '!' expression",
"expression : '-' expression",
"expression : '~' expression",
"expression : expression '?' expression ':' expression",
"expression : simple_assignment",
"expression : function",
"expression : constant",
"expression : variable",
"expression : '(' expression ')'",
"function : absolute_function",
"function : addr_function",
"function : align_function",
"function : alignof_function",
"function : block_function",
"function : data_segment_align_function",
"function : data_segment_end_function",
"function : data_segment_relro_end_function",
"function : defined_function",
"function : length_function",
"function : loadaddr_function",
"function : max_function",
"function : min_function",
"function : next_function",
"function : origin_function",
"function : segment_start_function",
"function : sizeof_function",
"function : sizeof_headers_function",
"absolute_function : T_ABSOLUTE '(' expression ')'",
"addr_function : T_ADDR '(' ident ')'",
"align_function : T_ALIGN '(' expression ')'",
"align_function : T_ALIGN '(' expression ',' expression ')'",
"alignof_function : T_ALIGNOF '(' ident ')'",
"block_function : T_BLOCK '(' expression ')'",
"data_segment_align_function : T_DATA_SEGMENT_ALIGN '(' expression ',' expression ')'",
"data_segment_end_function : T_DATA_SEGMENT_END '(' expression ')'",
"data_segment_relro_end_function : T_DATA_SEGMENT_RELRO_END '(' expression ',' expression ')'",
"defined_function : T_DEFINED '(' ident ')'",
"length_function : T_LENGTH '(' ident ')'",
"loadaddr_function : T_LOADADDR '(' ident ')'",
"max_function : T_MAX '(' expression ',' expression ')'",
"min_function : T_MIN '(' expression ',' expression ')'",
"next_function : T_NEXT '(' expression ')'",
"origin_function : T_ORIGIN '(' ident ')'",
"segment_start_function : T_SEGMENT_START '(' ident ',' expression ')'",
"sizeof_function : T_SIZEOF '(' ident ')'",
"sizeof_headers_function : T_SIZEOF_HEADERS",
"constant : T_NUM",
"constant : symbolic_constant",
"symbolic_constant : T_CONSTANT '(' T_COMMONPAGESIZE ')'",
"symbolic_constant : T_CONSTANT '(' T_MAXPAGESIZE ')'",
"ldscript_command : assert_command",
"ldscript_command : assignment",
"ldscript_command : entry_command",
"ldscript_command : extern_command",
"ldscript_command : force_common_allocation_command",
"ldscript_command : group_command",
"ldscript_command : inhibit_common_allocation_command",
"ldscript_command : input_command",
"ldscript_command : memory_command",
"ldscript_command : nocrossrefs_command",
"ldscript_command : output_command",
"ldscript_command : output_arch_command",
"ldscript_command : output_format_command",
"ldscript_command : phdrs_command",
"ldscript_command : region_alias_command",
"ldscript_command : search_dir_command",
"ldscript_command : sections_command",
"ldscript_command : startup_command",
"ldscript_command : target_command",
"ldscript_command : version_script_node",
"ldscript_command : ';'",
"assignment : simple_assignment",
"assignment : provide_assignment",
"assignment : provide_hidden_assignment",
"simple_assignment : variable assign_op expression",
"provide_assignment : T_PROVIDE '(' variable '=' expression ')'",
"provide_hidden_assignment : T_PROVIDE_HIDDEN '(' variable '=' expression ')'",
"assign_op : T_LSHIFT_E",
"assign_op : T_RSHIFT_E",
"assign_op : T_ADD_E",
"assign_op : T_SUB_E",
"assign_op : T_MUL_E",
"assign_op : T_DIV_E",
"assign_op : T_AND_E",
"assign_op : T_OR_E",
"assign_op : '='",
"assert_command : T_ASSERT '(' expression ',' T_STRING ')'",
"entry_command : T_ENTRY '(' ident ')'",
"extern_command : T_EXTERN '(' ident_list_nosep ')'",
"force_common_allocation_command : T_FORCE_COMMON_ALLOCATION",
"group_command : T_GROUP '(' input_file_list ')'",
"inhibit_common_allocation_command : T_INHIBIT_COMMON_ALLOCATION",
"input_command : T_INPUT '(' input_file_list ')'",
"memory_command : T_MEMORY '{' memory_region_list '}'",
"memory_region_list : memory_region",
"memory_region_list : memory_region_list memory_region",
"memory_region : ident memory_attr ':' T_ORIGIN '=' expression ',' T_LENGTH '=' expression",
"memory_attr : T_MEMORY_ATTR",
"memory_attr :",
"nocrossrefs_command : T_NOCROSSREFS '(' ident_list_nosep ')'",
"output_command : T_OUTPUT '(' ident ')'",
"output_arch_command : T_OUTPUT_ARCH '(' ident ')'",
"output_format_command : T_OUTPUT_FORMAT '(' ident ')'",
"output_format_command : T_OUTPUT_FORMAT '(' ident ',' ident ',' ident ')'",
"phdrs_command : T_PHDRS '{' phdr_list '}'",
"phdr_list : phdr",
"phdr_list : phdr_list phdr",
"phdr : ident ident phdr_filehdr phdr_phdrs phdr_at phdr_flags ';'",
"phdr_filehdr : T_FILEHDR",
"phdr_filehdr :",
"phdr_phdrs : T_PHDRS",
"phdr_phdrs :",
"phdr_at : T_AT '(' expression ')'",
"phdr_at :",
"phdr_flags : T_FLAGS '(' T_NUM ')'",
"phdr_flags :",
"region_alias_command : T_REGION_ALIAS '(' ident ',' ident ')'",
"search_dir_command : T_SEARCH_DIR '(' ident ')'",
"sections_command : T_SECTIONS '{' sections_command_list '}'",
"sections_command_list : sections_sub_command",
"sections_command_list : sections_command_list sections_sub_command",
"sections_sub_command : entry_command",
"sections_sub_command : assignment",
"sections_sub_command : output_sections_desc",
"sections_sub_command : overlay_desc",
"sections_sub_command : ';'",
"$$1 :",
"output_sections_desc : ident output_section_addr_and_type ':' $$1 output_section_lma output_section_align output_section_subalign output_section_constraint '{' output_section_command_list '}' output_section_region output_section_lma_region output_section_phdr output_section_fillexp",
"output_section_addr_and_type : output_section_addr output_section_type",
"output_section_addr_and_type : output_section_type",
"output_section_addr : expression",
"output_section_type : '(' output_section_type_keyword ')'",
"output_section_type : '(' ')'",
"output_section_type :",
"output_section_type_keyword : T_COPY",
"output_section_type_keyword : T_DSECT",
"output_section_type_keyword : T_INFO",
"output_section_type_keyword : T_NOLOAD",
"output_section_type_keyword : T_OVERLAY",
"output_section_lma : T_AT '(' expression ')'",
"output_section_lma :",
"output_section_align : T_ALIGN '(' expression ')'",
"output_section_align :",
"output_section_subalign : T_SUBALIGN '(' expression ')'",
"output_section_subalign :",
"output_section_constraint : T_ONLY_IF_RO",
"output_section_constraint : T_ONLY_IF_RW",
"output_section_constraint :",
"output_section_command_list : output_section_command",
"output_section_command_list : output_section_command_list output_section_command",
"output_section_command : assignment",
"output_section_command : input_section_desc",
"output_section_command : output_section_data",
"output_section_command : output_section_keywords",
"output_section_command : ';'",
"input_section_desc : input_section_desc_no_keep",
"input_section_desc : T_KEEP '(' input_section_desc_no_keep ')'",
"input_section_desc_no_keep : wildcard_sort input_section",
"input_section_desc_no_keep : wildcard_sort ':' wildcard_sort input_section",
"input_section : '(' T_EXCLUDE_FILE '(' wildcard_list ')' wildcard_list ')'",
"input_section : '(' wildcard_list ')'",
"output_section_data : data_type '(' expression ')'",
"data_type : T_BYTE",
"data_type : T_SHORT",
"data_type : T_LONG",
"data_type : T_QUAD",
"data_type : T_SQUAD",
"data_type : T_FILL",
"output_section_keywords : T_CREATE_OBJECT_SYMBOLS",
"output_section_keywords : T_CONSTRUCTORS",
"output_section_keywords : T_SORT_BY_NAME '(' T_CONSTRUCTORS ')'",
"output_section_region : '>' ident",
"output_section_region :",
"output_section_lma_region : T_AT '>' ident",
"output_section_lma_region :",
"output_section_phdr : output_section_phdr ':' ident",
"output_section_phdr :",
"output_section_fillexp : '=' expression",
"output_section_fillexp :",
"overlay_desc : T_OVERLAY overlay_vma ':' overlay_nocref output_section_lma '{' overlay_section_list '}' output_section_region output_section_phdr output_section_fillexp",
"overlay_vma : expression",
"overlay_vma :",
"overlay_nocref : T_NOCROSSREFS",
"overlay_nocref :",
"overlay_section_list : overlay_section",
"overlay_section_list : overlay_section_list overlay_section",
"overlay_section : ident '{' output_section_command_list '}' output_section_phdr output_section_fillexp",
"startup_command : T_STARTUP '(' ident ')'",
"target_command : T_TARGET '(' ident ')'",
"version_script_node : ident extern_block version_dependency ';'",
"version_script_node : ident version_block version_dependency ';'",
"version_script_node : extern_block version_dependency ';'",
"version_script_node : version_block version_dependency ';'",
"extern_block : T_VER_EXTERN T_STRING version_block",
"version_block : '{' version_entry_list '}'",
"version_entry_list : version_entry",
"version_entry_list : version_entry_list version_entry",
"version_entry : T_VER_GLOBAL",
"version_entry : T_VER_LOCAL",
"version_entry : wildcard ';'",
"version_entry : extern_block ';'",
"version_dependency : ident",
"version_dependency :",
"ident : T_IDENT",
"ident : T_STRING",
"variable : ident",
"variable : '.'",
"wildcard : ident",
"wildcard : T_WILDCARD",
"wildcard : '*'",
"wildcard : '?'",
"wildcard_sort : wildcard",
"wildcard_sort : T_SORT_BY_NAME '(' wildcard ')'",
"wildcard_sort : T_SORT_BY_NAME '(' T_SORT_BY_NAME '(' wildcard ')' ')'",
"wildcard_sort : T_SORT_BY_NAME '(' T_SORT_BY_ALIGNMENT '(' wildcard ')' ')'",
"wildcard_sort : T_SORT_BY_ALIGNMENT '(' wildcard ')'",
"wildcard_sort : T_SORT_BY_ALIGNMENT '(' T_SORT_BY_NAME '(' wildcard ')' ')'",
"wildcard_sort : T_SORT_BY_ALIGNMENT '(' T_SORT_BY_ALIGNMENT '(' wildcard ')' ')'",
"ident_list : ident",
"ident_list : ident_list separator ident",
"ident_list_nosep : ident",
"ident_list_nosep : ident_list_nosep ident",
"input_file_list : input_file",
"input_file_list : input_file_list separator input_file",
"input_file : ident",
"input_file : as_needed_list",
"as_needed_list : T_AS_NEEDED '(' ident_list ')'",
"wildcard_list : wildcard_sort",
"wildcard_list : wildcard_list wildcard_sort",
"separator : ','",
"separator :",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 1185 "ld_script_parser.y"

/* ARGSUSED */
static void
yyerror(const char *s)
{

	(void) s;
	errx(1, "Syntax error in ld script, line %d\n", lineno);
}

static void
_init_script(void)
{

	STAILQ_INIT(&ldss_c);
	STAILQ_INIT(&ldso_c);
}

void
ld_script_parse(const char *name)
{
	YY_BUFFER_STATE b;

	_init_script();

	if ((yyin = fopen(name, "r")) == NULL)
		ld_fatal_std(ld, "fopen %s name failed", name);
	b = yy_create_buffer(yyin, YY_BUF_SIZE);
	yy_switch_to_buffer(b);
	if (yyparse() < 0)
		ld_fatal(ld, "unable to parse linker script %s", name);
	yy_delete_buffer(b);
}

void
ld_script_parse_internal(void)
{
	YY_BUFFER_STATE b;

	_init_script();

	assert(ld->ld_arch != NULL && ld->ld_arch->script != NULL);
	b = yy_scan_string(ld->ld_arch->script);
	yy_switch_to_buffer(b);
	if (yyparse() < 0)
		ld_fatal(ld, "unable to parse internal linker script");
	yy_delete_buffer(b);
}
#line 2454 "ld_script_parser.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 3:
#line 284 "ld_script_parser.y"
	{
		if (yystack.l_mark[0].cmd != NULL)
			ld_script_cmd_insert(&ld->ld_scp->lds_c, yystack.l_mark[0].cmd);
	}
break;
case 4:
#line 288 "ld_script_parser.y"
	{
		if (yystack.l_mark[0].cmd != NULL)
			ld_script_cmd_insert(&ld->ld_scp->lds_c, yystack.l_mark[0].cmd);
	}
break;
case 5:
#line 295 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_ADD, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 6:
#line 298 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_SUBSTRACT, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 7:
#line 301 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_MUL, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 8:
#line 304 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_DIV, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 9:
#line 307 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_MOD, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 10:
#line 310 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_AND, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 11:
#line 313 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_OR, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 12:
#line 316 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_GREATER, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 13:
#line 319 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_LESSER, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 14:
#line 322 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_EQUAL, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 15:
#line 325 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_NE, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 16:
#line 328 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_GE, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 17:
#line 331 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_LE, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 18:
#line 334 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_LSHIFT, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 19:
#line 337 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_RSHIFT, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 20:
#line 340 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_LOGICAL_AND, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 21:
#line 343 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_LOGICAL_OR, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 22:
#line 346 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_NOT, yystack.l_mark[0].exp);
	}
break;
case 23:
#line 349 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_MINUS, yystack.l_mark[0].exp);
	}
break;
case 24:
#line 352 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_NEGATION, yystack.l_mark[0].exp);
	}
break;
case 25:
#line 355 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_trinary(ld, yystack.l_mark[-4].exp, yystack.l_mark[-2].exp, yystack.l_mark[0].exp);
	}
break;
case 26:
#line 358 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_assign(ld, yystack.l_mark[0].assign);
	}
break;
case 30:
#line 364 "ld_script_parser.y"
	{ yyval.exp = yystack.l_mark[-1].exp;	yyval.exp->le_par = 1; }
break;
case 49:
#line 389 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_ABS, yystack.l_mark[-1].exp);
	}
break;
case 50:
#line 395 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_ADDR, ld_exp_name(ld, yystack.l_mark[-1].str));
	}
break;
case 51:
#line 401 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_ALIGN, yystack.l_mark[-1].exp);
	}
break;
case 52:
#line 404 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_ALIGN, yystack.l_mark[-3].exp, yystack.l_mark[-1].exp);
	}
break;
case 53:
#line 410 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_ALIGNOF, ld_exp_name(ld, yystack.l_mark[-1].str));
	}
break;
case 54:
#line 416 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_BLOCK, yystack.l_mark[-1].exp);
	}
break;
case 55:
#line 422 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_DSA, yystack.l_mark[-3].exp, yystack.l_mark[-1].exp);
	}
break;
case 56:
#line 428 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_DSE, yystack.l_mark[-1].exp);
	}
break;
case 57:
#line 434 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_DSRE, yystack.l_mark[-3].exp, yystack.l_mark[-1].exp);
	}
break;
case 58:
#line 440 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_DEFINED, ld_exp_symbol(ld, yystack.l_mark[-1].str));
	}
break;
case 59:
#line 446 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_LENGTH, ld_exp_name(ld, yystack.l_mark[-1].str));
	}
break;
case 60:
#line 452 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_LOADADDR, ld_exp_name(ld, yystack.l_mark[-1].str));
	}
break;
case 61:
#line 458 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_MAX, yystack.l_mark[-3].exp, yystack.l_mark[-1].exp);
	}
break;
case 62:
#line 464 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_MIN, yystack.l_mark[-3].exp, yystack.l_mark[-1].exp);
	}
break;
case 63:
#line 470 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_NEXT, yystack.l_mark[-1].exp);
	}
break;
case 64:
#line 476 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_ORIGIN, ld_exp_name(ld, yystack.l_mark[-1].str));
	}
break;
case 65:
#line 482 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_binary(ld, LEOP_MIN, ld_exp_name(ld, yystack.l_mark[-3].str), yystack.l_mark[-1].exp);
	}
break;
case 66:
#line 488 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_unary(ld, LEOP_SIZEOF, ld_exp_name(ld, yystack.l_mark[-1].str));
	}
break;
case 67:
#line 494 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_sizeof_headers(ld);
	}
break;
case 68:
#line 500 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_constant(ld, yystack.l_mark[0].num);
	}
break;
case 69:
#line 503 "ld_script_parser.y"
	{
		yyval.exp = ld_exp_symbolic_constant(ld, yystack.l_mark[0].str);
	}
break;
case 70:
#line 509 "ld_script_parser.y"
	{ yyval.str = yystack.l_mark[-1].str; }
break;
case 71:
#line 510 "ld_script_parser.y"
	{ yyval.str = yystack.l_mark[-1].str; }
break;
case 73:
#line 515 "ld_script_parser.y"
	{
		if (*yystack.l_mark[0].assign->lda_var->le_name == '.')
			ld_fatal(ld, "variable . can only be used inside"
			    " SECTIONS command");
		yyval.cmd = ld_script_cmd(ld, LSC_ASSIGN, yystack.l_mark[0].assign);
	}
break;
case 75:
#line 522 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 76:
#line 523 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 77:
#line 524 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 78:
#line 525 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 79:
#line 526 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 80:
#line 527 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 81:
#line 528 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 82:
#line 529 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 83:
#line 530 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 84:
#line 531 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 85:
#line 532 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 86:
#line 533 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 87:
#line 534 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 89:
#line 536 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 90:
#line 537 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 91:
#line 538 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 92:
#line 539 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 96:
#line 549 "ld_script_parser.y"
	{
		yyval.assign = ld_script_assign(ld, yystack.l_mark[-2].exp, yystack.l_mark[-1].num, yystack.l_mark[0].exp, 0, 0);
	}
break;
case 97:
#line 555 "ld_script_parser.y"
	{
		yyval.assign = ld_script_assign(ld, yystack.l_mark[-3].exp, LSAOP_E, yystack.l_mark[-1].exp, 1, 0);
	}
break;
case 98:
#line 561 "ld_script_parser.y"
	{
		yyval.assign = ld_script_assign(ld, yystack.l_mark[-3].exp, LSAOP_E, yystack.l_mark[-1].exp, 1, 1);
	}
break;
case 99:
#line 567 "ld_script_parser.y"
	{ yyval.num = LSAOP_LSHIFT_E; }
break;
case 100:
#line 568 "ld_script_parser.y"
	{ yyval.num = LSAOP_RSHIFT_E; }
break;
case 101:
#line 569 "ld_script_parser.y"
	{ yyval.num = LSAOP_ADD_E; }
break;
case 102:
#line 570 "ld_script_parser.y"
	{ yyval.num = LSAOP_SUB_E; }
break;
case 103:
#line 571 "ld_script_parser.y"
	{ yyval.num = LSAOP_MUL_E; }
break;
case 104:
#line 572 "ld_script_parser.y"
	{ yyval.num = LSAOP_DIV_E; }
break;
case 105:
#line 573 "ld_script_parser.y"
	{ yyval.num = LSAOP_AND_E; }
break;
case 106:
#line 574 "ld_script_parser.y"
	{ yyval.num = LSAOP_OR_E; }
break;
case 107:
#line 575 "ld_script_parser.y"
	{ yyval.num = LSAOP_E; }
break;
case 108:
#line 579 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_assert(ld, yystack.l_mark[-3].exp, yystack.l_mark[-1].str);
	}
break;
case 109:
#line 585 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_ENTRY, yystack.l_mark[-1].str);
	}
break;
case 110:
#line 591 "ld_script_parser.y"
	{ ld_script_extern(ld, yystack.l_mark[-1].list); }
break;
case 111:
#line 595 "ld_script_parser.y"
	{ ld->ld_common_alloc = 1; }
break;
case 112:
#line 599 "ld_script_parser.y"
	{
		 ld_script_group(ld, ld_script_list_reverse(yystack.l_mark[-1].list));
	}
break;
case 113:
#line 605 "ld_script_parser.y"
	{ ld->ld_common_no_alloc = 1; }
break;
case 114:
#line 609 "ld_script_parser.y"
	{
		ld_script_input(ld, ld_script_list_reverse(yystack.l_mark[-1].list));
	}
break;
case 116:
#line 619 "ld_script_parser.y"
	{
		STAILQ_INSERT_TAIL(&ld->ld_scp->lds_r, yystack.l_mark[0].region, ldsr_next);
	}
break;
case 117:
#line 622 "ld_script_parser.y"
	{
		STAILQ_INSERT_TAIL(&ld->ld_scp->lds_r, yystack.l_mark[0].region, ldsr_next);
	}
break;
case 118:
#line 629 "ld_script_parser.y"
	{
		ld_script_region(ld, yystack.l_mark[-9].str, yystack.l_mark[-8].str, yystack.l_mark[-4].exp, yystack.l_mark[0].exp);
	}
break;
case 120:
#line 636 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 121:
#line 640 "ld_script_parser.y"
	{
		ld_script_nocrossrefs(ld, yystack.l_mark[-1].list);
	}
break;
case 122:
#line 646 "ld_script_parser.y"
	{
		if (ld->ld_output == NULL)
			ld->ld_output_file = yystack.l_mark[-1].str;
		else
			free(yystack.l_mark[-1].str);
	}
break;
case 123:
#line 655 "ld_script_parser.y"
	{
		ld_arch_set(ld, yystack.l_mark[-1].str);
		free(yystack.l_mark[-1].str);
	}
break;
case 124:
#line 662 "ld_script_parser.y"
	{
		ld_output_format(ld, yystack.l_mark[-1].str, yystack.l_mark[-1].str, yystack.l_mark[-1].str);
	}
break;
case 125:
#line 665 "ld_script_parser.y"
	{
		ld_output_format(ld, yystack.l_mark[-5].str, yystack.l_mark[-3].str, yystack.l_mark[-1].str);
	}
break;
case 127:
#line 675 "ld_script_parser.y"
	{
		STAILQ_INSERT_TAIL(&ld->ld_scp->lds_p, yystack.l_mark[0].phdr, ldsp_next);
	}
break;
case 128:
#line 678 "ld_script_parser.y"
	{
		STAILQ_INSERT_TAIL(&ld->ld_scp->lds_p, yystack.l_mark[0].phdr, ldsp_next);
	}
break;
case 129:
#line 683 "ld_script_parser.y"
	{
		yyval.phdr = ld_script_phdr(ld, yystack.l_mark[-6].str, yystack.l_mark[-5].str, yystack.l_mark[-4].num, yystack.l_mark[-3].num, yystack.l_mark[-2].exp, yystack.l_mark[-1].num);
	}
break;
case 130:
#line 689 "ld_script_parser.y"
	{ yyval.num = 1; }
break;
case 131:
#line 690 "ld_script_parser.y"
	{ yyval.num = 0; }
break;
case 132:
#line 694 "ld_script_parser.y"
	{ yyval.num = 1; }
break;
case 133:
#line 695 "ld_script_parser.y"
	{ yyval.num = 0; }
break;
case 134:
#line 699 "ld_script_parser.y"
	{ yyval.exp = yystack.l_mark[-1].exp; }
break;
case 135:
#line 700 "ld_script_parser.y"
	{ yyval.exp = NULL; }
break;
case 136:
#line 704 "ld_script_parser.y"
	{ yyval.num = yystack.l_mark[-1].num; }
break;
case 137:
#line 705 "ld_script_parser.y"
	{ yyval.num = 0; }
break;
case 138:
#line 709 "ld_script_parser.y"
	{
		ld_script_region_alias(ld, yystack.l_mark[-3].str, yystack.l_mark[-1].str);
	}
break;
case 139:
#line 715 "ld_script_parser.y"
	{
		ld_path_add(ld, yystack.l_mark[-1].str, LPT_L);
		free(yystack.l_mark[-1].str);
	}
break;
case 140:
#line 722 "ld_script_parser.y"
	{
		struct ld_script_sections *ldss;
		ldss = malloc(sizeof(struct ld_script_sections));
		if (ldss == NULL)
			ld_fatal_std(ld, "malloc");
		memcpy(&ldss->ldss_c, &ldss_c, sizeof(ldss_c));
		yyval.cmd = ld_script_cmd(ld, LSC_SECTIONS, ldss);
		STAILQ_INIT(&ldss_c);
	}
break;
case 141:
#line 734 "ld_script_parser.y"
	{
		if (yystack.l_mark[0].cmd != NULL)
			ld_script_cmd_insert(&ldss_c, yystack.l_mark[0].cmd);
	}
break;
case 142:
#line 738 "ld_script_parser.y"
	{
		if (yystack.l_mark[0].cmd != NULL)
			ld_script_cmd_insert(&ldss_c, yystack.l_mark[0].cmd);
	}
break;
case 144:
#line 746 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_ASSIGN, yystack.l_mark[0].assign);
	}
break;
case 145:
#line 749 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_SECTIONS_OUTPUT, yystack.l_mark[0].output_desc);
	}
break;
case 146:
#line 752 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_SECTIONS_OVERLAY, yystack.l_mark[0].overlay_desc);
	}
break;
case 147:
#line 755 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 148:
#line 759 "ld_script_parser.y"
	{
		/* Remember the name of last output section, needed later for assignment. */
		ld->ld_scp->lds_base_os_name = yystack.l_mark[-2].str;
	}
break;
case 149:
#line 771 "ld_script_parser.y"
	{
		yyval.output_desc = calloc(1, sizeof(struct ld_script_sections_output));
		if (yyval.output_desc == NULL)
			ld_fatal_std(ld, "calloc");
		yyval.output_desc->ldso_name = yystack.l_mark[-14].str;
		yyval.output_desc->ldso_vma = yystack.l_mark[-13].list->ldl_entry;
		yyval.output_desc->ldso_type = yystack.l_mark[-13].list->ldl_next->ldl_entry;
		yyval.output_desc->ldso_lma = yystack.l_mark[-10].exp;
		yyval.output_desc->ldso_align = yystack.l_mark[-9].exp;
		yyval.output_desc->ldso_subalign = yystack.l_mark[-8].exp;
		yyval.output_desc->ldso_constraint = yystack.l_mark[-7].str;
		memcpy(&yyval.output_desc->ldso_c, &ldso_c, sizeof(ldso_c));
		yyval.output_desc->ldso_region = yystack.l_mark[-3].str;
		yyval.output_desc->ldso_lma_region = yystack.l_mark[-2].str;
		yyval.output_desc->ldso_phdr = ld_script_list_reverse(yystack.l_mark[-1].list);
		yyval.output_desc->ldso_fill = yystack.l_mark[0].exp;
		STAILQ_INIT(&ldso_c);
		ld->ld_scp->lds_base_os_name = 0;
		ld->ld_scp->lds_last_os_name = yystack.l_mark[-14].str;
	}
break;
case 150:
#line 794 "ld_script_parser.y"
	{
		yyval.list = ld_script_list(ld, NULL, yystack.l_mark[0].str);
		yyval.list = ld_script_list(ld, yyval.list, yystack.l_mark[-1].exp);
	}
break;
case 151:
#line 798 "ld_script_parser.y"
	{
		yyval.list = ld_script_list(ld, NULL, NULL);
		yyval.list = ld_script_list(ld, yyval.list, yystack.l_mark[0].str);
	}
break;
case 153:
#line 809 "ld_script_parser.y"
	{ yyval.str = yystack.l_mark[-1].str; }
break;
case 154:
#line 810 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 155:
#line 811 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 161:
#line 823 "ld_script_parser.y"
	{ yyval.exp = yystack.l_mark[-1].exp; }
break;
case 162:
#line 824 "ld_script_parser.y"
	{ yyval.exp = NULL; }
break;
case 163:
#line 828 "ld_script_parser.y"
	{ yyval.exp = yystack.l_mark[-1].exp; }
break;
case 164:
#line 829 "ld_script_parser.y"
	{ yyval.exp = NULL; }
break;
case 165:
#line 833 "ld_script_parser.y"
	{ yyval.exp = yystack.l_mark[-1].exp; }
break;
case 166:
#line 834 "ld_script_parser.y"
	{ yyval.exp = NULL; }
break;
case 169:
#line 840 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 170:
#line 844 "ld_script_parser.y"
	{
		if (yystack.l_mark[0].cmd != NULL)
			ld_script_cmd_insert(&ldso_c, yystack.l_mark[0].cmd);
	}
break;
case 171:
#line 848 "ld_script_parser.y"
	{
		if (yystack.l_mark[0].cmd != NULL)
			ld_script_cmd_insert(&ldso_c, yystack.l_mark[0].cmd);
	}
break;
case 172:
#line 855 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_ASSIGN, yystack.l_mark[0].assign);
	}
break;
case 173:
#line 858 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_SECTIONS_OUTPUT_INPUT, yystack.l_mark[0].input_section);
	}
break;
case 174:
#line 861 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_SECTIONS_OUTPUT_DATA, yystack.l_mark[0].output_data);
	}
break;
case 175:
#line 864 "ld_script_parser.y"
	{
		yyval.cmd = ld_script_cmd(ld, LSC_SECTIONS_OUTPUT_KEYWORD,
		    (void *) (uintptr_t) yystack.l_mark[0].num);
	}
break;
case 176:
#line 868 "ld_script_parser.y"
	{ yyval.cmd = NULL; }
break;
case 177:
#line 872 "ld_script_parser.y"
	{
		yystack.l_mark[0].input_section->ldoi_keep = 0;
		yyval.input_section = yystack.l_mark[0].input_section;
	}
break;
case 178:
#line 876 "ld_script_parser.y"
	{
		yystack.l_mark[-1].input_section->ldoi_keep = 0;
		yyval.input_section = yystack.l_mark[-1].input_section;
	}
break;
case 179:
#line 883 "ld_script_parser.y"
	{
		yystack.l_mark[0].input_section->ldoi_ar = NULL;
		yystack.l_mark[0].input_section->ldoi_file = yystack.l_mark[-1].wildcard;
		yyval.input_section = yystack.l_mark[0].input_section;
	}
break;
case 180:
#line 888 "ld_script_parser.y"
	{
		yystack.l_mark[0].input_section->ldoi_ar = yystack.l_mark[-3].wildcard;
		yystack.l_mark[0].input_section->ldoi_ar = yystack.l_mark[-1].wildcard;
		yyval.input_section = yystack.l_mark[0].input_section;
	}
break;
case 181:
#line 896 "ld_script_parser.y"
	{
		yyval.input_section = calloc(1, sizeof(struct ld_script_sections_output_input));
		if (yyval.input_section == NULL)
			ld_fatal_std(ld, "calloc");
		yyval.input_section->ldoi_exclude = ld_script_list_reverse(yystack.l_mark[-3].list);
		yyval.input_section->ldoi_sec = ld_script_list_reverse(yystack.l_mark[-1].list);
	}
break;
case 182:
#line 903 "ld_script_parser.y"
	{
		yyval.input_section = calloc(1, sizeof(struct ld_script_sections_output_input));
		if (yyval.input_section == NULL)
			ld_fatal_std(ld, "calloc");
		yyval.input_section->ldoi_exclude = NULL;
		yyval.input_section->ldoi_sec = ld_script_list_reverse(yystack.l_mark[-1].list);
	}
break;
case 183:
#line 913 "ld_script_parser.y"
	{
		yyval.output_data = calloc(1, sizeof(struct ld_script_sections_output_data));
		if (yyval.output_data == NULL)
			ld_fatal_std(ld, "calloc");
		yyval.output_data->ldod_type = yystack.l_mark[-3].num;
		yyval.output_data->ldod_exp = yystack.l_mark[-1].exp;
	}
break;
case 184:
#line 923 "ld_script_parser.y"
	{ yyval.num = LSODT_BYTE; }
break;
case 185:
#line 924 "ld_script_parser.y"
	{ yyval.num = LSODT_SHORT; }
break;
case 186:
#line 925 "ld_script_parser.y"
	{ yyval.num = LSODT_LONG; }
break;
case 187:
#line 926 "ld_script_parser.y"
	{ yyval.num = LSODT_QUAD; }
break;
case 188:
#line 927 "ld_script_parser.y"
	{ yyval.num = LSODT_SQUAD; }
break;
case 189:
#line 928 "ld_script_parser.y"
	{ yyval.num = LSODT_FILL; }
break;
case 190:
#line 932 "ld_script_parser.y"
	{
		yyval.num = LSOK_CREATE_OBJECT_SYMBOLS;
	}
break;
case 191:
#line 935 "ld_script_parser.y"
	{
		yyval.num = LSOK_CONSTRUCTORS;
	}
break;
case 192:
#line 938 "ld_script_parser.y"
	{
		yyval.num = LSOK_CONSTRUCTORS_SORT_BY_NAME;
	}
break;
case 193:
#line 944 "ld_script_parser.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 194:
#line 945 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 195:
#line 949 "ld_script_parser.y"
	{ yyval.str = yystack.l_mark[0].str; }
break;
case 196:
#line 950 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 197:
#line 954 "ld_script_parser.y"
	{
		yyval.list = ld_script_list(ld, yyval.list, yystack.l_mark[0].str);
	}
break;
case 198:
#line 957 "ld_script_parser.y"
	{ yyval.list = NULL; }
break;
case 199:
#line 962 "ld_script_parser.y"
	{ yyval.exp = yystack.l_mark[0].exp; }
break;
case 200:
#line 963 "ld_script_parser.y"
	{ yyval.exp = NULL; }
break;
case 201:
#line 974 "ld_script_parser.y"
	{
		yyval.overlay_desc = calloc(1, sizeof(struct ld_script_sections_overlay));
		if (yyval.overlay_desc == NULL)
			ld_fatal_std(ld, "calloc");
		yyval.overlay_desc->ldso_vma = yystack.l_mark[-9].exp;
		yyval.overlay_desc->ldso_nocrossref = !!yystack.l_mark[-7].num;
		yyval.overlay_desc->ldso_lma = yystack.l_mark[-6].exp;
		yyval.overlay_desc->ldso_s = yystack.l_mark[-4].list;
		yyval.overlay_desc->ldso_region = yystack.l_mark[-2].str;
		yyval.overlay_desc->ldso_phdr = yystack.l_mark[-1].list;
		yyval.overlay_desc->ldso_fill = yystack.l_mark[0].exp;
	}
break;
case 203:
#line 990 "ld_script_parser.y"
	{ yyval.exp = NULL; }
break;
case 204:
#line 994 "ld_script_parser.y"
	{ yyval.num = 1; }
break;
case 205:
#line 995 "ld_script_parser.y"
	{ yyval.num = 0; }
break;
case 206:
#line 999 "ld_script_parser.y"
	{
		yyval.list = ld_script_list(ld, NULL, yystack.l_mark[0].overlay_section);
	}
break;
case 207:
#line 1002 "ld_script_parser.y"
	{
		yyval.list = ld_script_list(ld, yystack.l_mark[-1].list, yystack.l_mark[0].overlay_section);
	}
break;
case 208:
#line 1011 "ld_script_parser.y"
	{
		yyval.overlay_section = calloc(1,
		    sizeof(struct ld_script_sections_overlay_section));
		if (yyval.overlay_section == NULL)
			ld_fatal_std(ld, "calloc");
		yyval.overlay_section->ldos_name = yystack.l_mark[-5].str;
		memcpy(&yyval.overlay_section->ldos_c, &ldso_c, sizeof(ldso_c));
		yyval.overlay_section->ldos_phdr = yystack.l_mark[-1].list;
		yyval.overlay_section->ldos_fill = yystack.l_mark[0].exp;
		STAILQ_INIT(&ldso_c);
	}
break;
case 209:
#line 1025 "ld_script_parser.y"
	{
		ld_file_add_first(ld, yystack.l_mark[-1].str, LFT_UNKNOWN);
		free(yystack.l_mark[-1].str);
	}
break;
case 211:
#line 1036 "ld_script_parser.y"
	{
		ld_script_version_add_node(ld, yystack.l_mark[-3].str, yystack.l_mark[-2].version_entry_head, yystack.l_mark[-1].str);
	}
break;
case 212:
#line 1039 "ld_script_parser.y"
	{
		ld_script_version_add_node(ld, yystack.l_mark[-3].str, yystack.l_mark[-2].version_entry_head, yystack.l_mark[-1].str);
	}
break;
case 213:
#line 1042 "ld_script_parser.y"
	{
		ld_script_version_add_node(ld, NULL, yystack.l_mark[-2].version_entry_head, yystack.l_mark[-1].str);
	}
break;
case 214:
#line 1045 "ld_script_parser.y"
	{
		ld_script_version_add_node(ld, NULL, yystack.l_mark[-2].version_entry_head, yystack.l_mark[-1].str);
	}
break;
case 215:
#line 1051 "ld_script_parser.y"
	{
		ld_script_version_set_lang(ld, yystack.l_mark[0].version_entry_head, yystack.l_mark[-1].str);
		yyval.version_entry_head = yystack.l_mark[0].version_entry_head;
	}
break;
case 216:
#line 1058 "ld_script_parser.y"
	{
		yyval.version_entry_head = yystack.l_mark[-1].version_entry_head;
		ld->ld_state.ls_version_local = 0;
	}
break;
case 217:
#line 1065 "ld_script_parser.y"
	{
		yyval.version_entry_head = ld_script_version_link_entry(ld, NULL, yystack.l_mark[0].version_entry);
	}
break;
case 218:
#line 1068 "ld_script_parser.y"
	{
		yyval.version_entry_head = ld_script_version_link_entry(ld, yystack.l_mark[-1].version_entry_head, yystack.l_mark[0].version_entry);
	}
break;
case 219:
#line 1074 "ld_script_parser.y"
	{
		ld->ld_state.ls_version_local = 0;
		yyval.version_entry = NULL;
	}
break;
case 220:
#line 1078 "ld_script_parser.y"
	{
		ld->ld_state.ls_version_local = 1;
		yyval.version_entry = NULL;
	}
break;
case 221:
#line 1082 "ld_script_parser.y"
	{
		yyval.version_entry = ld_script_version_alloc_entry(ld, yystack.l_mark[-1].str, NULL);
	}
break;
case 222:
#line 1085 "ld_script_parser.y"
	{
		yyval.version_entry = ld_script_version_alloc_entry(ld, NULL, yystack.l_mark[-1].version_entry_head);
	}
break;
case 224:
#line 1092 "ld_script_parser.y"
	{ yyval.str = NULL; }
break;
case 227:
#line 1101 "ld_script_parser.y"
	{ yyval.exp = ld_exp_symbol(ld, yystack.l_mark[0].str); }
break;
case 228:
#line 1102 "ld_script_parser.y"
	{ yyval.exp = ld_exp_symbol(ld, "."); }
break;
case 231:
#line 1108 "ld_script_parser.y"
	{ yyval.str = strdup("*"); }
break;
case 232:
#line 1109 "ld_script_parser.y"
	{ yyval.str = strdup("?"); }
break;
case 233:
#line 1113 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[0].str;
		yyval.wildcard->lw_sort = LWS_NONE;
	}
break;
case 234:
#line 1118 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[-1].str;
		yyval.wildcard->lw_sort = LWS_NAME;
	}
break;
case 235:
#line 1123 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[-2].str;
		yyval.wildcard->lw_sort = LWS_NAME;
	}
break;
case 236:
#line 1128 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[-2].str;
		yyval.wildcard->lw_sort = LWS_NAME_ALIGN;
	}
break;
case 237:
#line 1133 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[-1].str;
		yyval.wildcard->lw_sort = LWS_ALIGN;
	}
break;
case 238:
#line 1138 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[-2].str;
		yyval.wildcard->lw_sort = LWS_ALIGN_NAME;
	}
break;
case 239:
#line 1143 "ld_script_parser.y"
	{
		yyval.wildcard = ld_wildcard_alloc(ld);
		yyval.wildcard->lw_name = yystack.l_mark[-2].str;
		yyval.wildcard->lw_sort = LWS_ALIGN;
	}
break;
case 240:
#line 1151 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, NULL, yystack.l_mark[0].str); }
break;
case 241:
#line 1152 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, yystack.l_mark[-2].list, yystack.l_mark[0].str); }
break;
case 242:
#line 1156 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, NULL, yystack.l_mark[0].str); }
break;
case 243:
#line 1157 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, yystack.l_mark[-1].list, yystack.l_mark[0].str); }
break;
case 244:
#line 1161 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, NULL, yystack.l_mark[0].input_file); }
break;
case 245:
#line 1162 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, yystack.l_mark[-2].list, yystack.l_mark[0].input_file); }
break;
case 246:
#line 1166 "ld_script_parser.y"
	{ yyval.input_file = ld_script_input_file(ld, 0, yystack.l_mark[0].str); }
break;
case 247:
#line 1167 "ld_script_parser.y"
	{ yyval.input_file = ld_script_input_file(ld, 1, yystack.l_mark[0].list); }
break;
case 248:
#line 1171 "ld_script_parser.y"
	{ yyval.list = yystack.l_mark[-1].list; }
break;
case 249:
#line 1175 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, NULL, yystack.l_mark[0].wildcard); }
break;
case 250:
#line 1176 "ld_script_parser.y"
	{ yyval.list = ld_script_list(ld, yystack.l_mark[-1].list, yystack.l_mark[0].wildcard); }
break;
#line 4261 "ld_script_parser.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
